"""This sets up nice color names, associated with the palette colornames.gp.
In order for colors to be saved in a cgm file, they must be placed in
a palette. This function provides a convenient way of handling that.

The palette must be explicitly specified for the colors to be used, by doing
the following:

palette('colornames.gp')

"""
def incrementer():
    "Returns an incremented integer on each call"
    try:
        incrementer.value += 1
    except AttributeError:
        incrementer.value = 0
    return incrementer.value

# --- The colors, in alphabetic order.
aliceblue = incrementer() # (240,248,255)
antiquewhite = incrementer() # (250,235,215)
aqua = incrementer() # (0,255,255)
aquamarine = incrementer() # (127,255,212)
azure = incrementer() # (240,255,255)
beige = incrementer() # (245,245,220)
bisque = incrementer() # (255,228,196)
black = incrementer() # (0,0,0)
blanchedalmond = incrementer() # (255,235,205)
blue = incrementer() # (0,0,255)
blueviolet = incrementer() # (138,43,226)
brown = incrementer() # (165,42,42)
burlywood = incrementer() # (222,184,135)
cadetblue = incrementer() # (95,158,160)
chartreuse = incrementer() # (127,255,0)
chocolate = incrementer() # (210,105,30)
coral = incrementer() # (255,127,80)
cornflowerblue = incrementer() # (100,149,237)
cornsilk = incrementer() # (255,248,220)
crimson = incrementer() # (220,20,60)
cyan = incrementer() # (0,255,255)
darkblue = incrementer() # (0,0,139)
darkcyan = incrementer() # (0,139,139)
darkgoldenrod = incrementer() # (184,134,11)
darkgray = incrementer() # (169,169,169)
darkgreen = incrementer() # (0,100,0)
darkgrey = incrementer() # (169,169,169)
darkkhaki = incrementer() # (189,183,107)
darkmagenta = incrementer() # (139,0,139)
darkolivegreen = incrementer() # (85,107,47)
darkorange = incrementer() # (255,140,0)
darkorchid = incrementer() # (153,50,204)
darkred = incrementer() # (139,0,0)
darksalmon = incrementer() # (233,150,122)
darkseagreen = incrementer() # (143,188,143)
darkslateblue = incrementer() # (72,61,139)
darkslategray = incrementer() # (47,79,79)
darkslategrey = incrementer() # (47,79,79)
darkturquoise = incrementer() # (0,206,209)
darkviolet = incrementer() # (148,0,211)
deeppink = incrementer() # (255,20,147)
deepskyblue = incrementer() # (0,191,255)
dimgray = incrementer() # (105,105,105)
dimgrey = incrementer() # (105,105,105)
dodgerblue = incrementer() # (30,144,255)
firebrick = incrementer() # (178,34,34)
floralwhite = incrementer() # (255,250,240)
forestgreen = incrementer() # (34,139,34)
fuchsia = incrementer() # (255,0,255)
gainsboro = incrementer() # (220,220,220)
ghostwhite = incrementer() # (248,248,255)
gold = incrementer() # (255,215,0)
goldenrod = incrementer() # (218,165,32)
gray = incrementer() # (128,128,128)
green = incrementer() # (0,128,0)
greenyellow = incrementer() # (173,255,47)
grey = incrementer() # (128,128,128)
honeydew = incrementer() # (240,255,240)
hotpink = incrementer() # (255,105,180)
indianred = incrementer() # (205,92,92)
indigo = incrementer() # (75,0,130)
ivory = incrementer() # (255,255,240)
khaki = incrementer() # (240,230,140)
lavender = incrementer() # (230,230,250)
lavenderblush = incrementer() # (255,240,245)
lawngreen = incrementer() # (124,252,0)
lemonchiffon = incrementer() # (255,250,205)
lightblue = incrementer() # (173,216,230)
lightcoral = incrementer() # (240,128,128)
lightcyan = incrementer() # (224,255,255)
lightgoldenrodyellow = incrementer() # (250,250,210)
lightgray = incrementer() # (211,211,211)
lightgreen = incrementer() # (144,238,144)
lightgrey = incrementer() # (211,211,211)
lightpink = incrementer() # (255,182,193)
lightsalmon = incrementer() # (255,160,122)
lightseagreen = incrementer() # (32,178,170)
lightskyblue = incrementer() # (135,206,250)
lightslategray = incrementer() # (119,136,153)
lightslategrey = incrementer() # (119,136,153)
lightsteelblue = incrementer() # (176,196,222)
lightyellow = incrementer() # (255,255,224)
lime = incrementer() # (0,255,0)
limegreen = incrementer() # (50,205,50)
linen = incrementer() # (250,240,230)
magenta = incrementer() # (255,0,255)
maroon = incrementer() # (128,0,0)
mediumaquamarine = incrementer() # (102,205,170)
mediumblue = incrementer() # (0,0,205)
mediumorchid = incrementer() # (186,85,211)
mediumpurple = incrementer() # (147,112,219)
mediumseagreen = incrementer() # (60,179,113)
mediumslateblue = incrementer() # (123,104,238)
mediumspringgreen = incrementer() # (0,250,154)
mediumturquoise = incrementer() # (72,209,204)
mediumvioletred = incrementer() # (199,21,133)
midnightblue = incrementer() # (25,25,112)
mintcream = incrementer() # (245,255,250)
mistyrose = incrementer() # (255,228,225)
moccasin = incrementer() # (255,228,181)
navajowhite = incrementer() # (255,222,173)
navy = incrementer() # (0,0,128)
oldlace = incrementer() # (253,245,230)
olive = incrementer() # (128,128,0)
olivedrab = incrementer() # (107,142,35)
orange = incrementer() # (255,165,0)
orangered = incrementer() # (255,69,0)
orchid = incrementer() # (218,112,214)
palegoldenrod = incrementer() # (238,232,170)
palegreen = incrementer() # (152,251,152)
paleturquoise = incrementer() # (175,238,238)
palevioletred = incrementer() # (219,112,147)
papayawhip = incrementer() # (255,239,213)
peachpuff = incrementer() # (255,218,185)
peru = incrementer() # (205,133,63)
pink = incrementer() # (255,192,203)
plum = incrementer() # (221,160,221)
powderblue = incrementer() # (176,224,230)
purple = incrementer() # (128,0,128)
red = incrementer() # (255,0,0)
rosybrown = incrementer() # (188,143,143)
royalblue = incrementer() # (65,105,225)
saddlebrown = incrementer() # (139,69,19)
salmon = incrementer() # (250,128,114)
sandybrown = incrementer() # (244,164,96)
seagreen = incrementer() # (46,139,87)
seashell = incrementer() # (255,245,238)
sienna = incrementer() # (160,82,45)
silver = incrementer() # (192,192,192)
skyblue = incrementer() # (135,206,235)
slateblue = incrementer() # (106,90,205)
slategray = incrementer() # (112,128,144)
slategrey = incrementer() # (112,128,144)
snow = incrementer() # (255,250,250)
springgreen = incrementer() # (0,255,127)
steelblue = incrementer() # (70,130,180)
tan = incrementer() # (210,180,140)
teal = incrementer() # (0,128,128)
thistle = incrementer() # (216,191,216)
tomato = incrementer() # (255,99,71)
turquoise = incrementer() # (64,224,208)
violet = incrementer() # (238,130,238)
wheat = incrementer() # (245,222,179)
white = incrementer() # (255,255,255)
whitesmoke = incrementer() # (245,245,245)
yellow = incrementer() # (255,255,0)
yellowgreen = incrementer() # (154,205,50)

