from warp import *

def aher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[0,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[0,:]

def apher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[1,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[1,:]

def bher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[2,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[2,:]

def bpher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[3,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[3,:]

def xher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[4,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[4,:]

def xpher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[5,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[5,:]

def yher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[6,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[6,:]

def ypher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[7,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[7,:]

def sher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[8,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[8,:]

def vzher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[9,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[9,:]

def enxher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[10,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[10,:]

def enyher(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[11,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[11,:]

def cur(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[12,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[12,:]

def dq(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[13,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[13,:]

def den(input=None,var=None):
  if not var: var = her.var
  if input:
    try: var[14,:] = input
    except: print 'input array not aligned for copy into var'
  else: return var[14,:]

def sethermesbeam(lsamecharge = false):
  """Initializes a Hermes beam.
Before calling this routine, env.zl and env.zu should be set to
cover exactly one half lattice period. Also, env.dzenv should be set.
 - lsamecharge = false : If true, all slices get the same amount of charge.
                       : The slice widths are adjusted in order 
                       : to get the desired current profile.
                       : If false, all slice widths are equal, and the slices
                       : get a different amount of charge in order to get the
                       : desired current profile.
The sethermesbeam routine calls sethermesprofile, sethermesenvelope,
and hermeserrorcheck consecutively.
  """
  print "Running sethermesbeam ..."
  sethermesprofile(lsamecharge)
  sethermesenvelope()
  hermeserrorcheck()
  print "done."
  
def sethermesprofile(lsamecharge):
  """Sets up the slice boundary positions and slice charges.
 - lsamecharge = false : If true, all slices get the same amount of charge.
                       : The slice widths are adjusted in order
                       : to get the desired current profile.
                       : If false, all slice widths are equal, and the slices
                       : get a different amount of charge in order to get the
                       : desired current profile.
  """
  delzbeam = top.zimax - top.zimin
  def f(z):
    fraction = (1.-top.straight)/2.
    if z <= 0.: return 0.
    if 0. < z <= fraction: return (1.-power(1.-z/fraction,her.iprofile))
    if fraction < z <= 1.-fraction: return 1.
    if 1.-fraction < z <= 1.: return (1.-power((z-1+fraction)/fraction,her.iprofile))
    if z > 1.: return 0.
  def fint(z):
    fraction = (1.-top.straight)/2.
    if z <= 0.:
      return 0.
    if 0. < z <= fraction:
      return (z + (fraction/(her.iprofile+1.))*(power(1-z/fraction,her.iprofile+1.)) - fraction/(her.iprofile+1.))
    if fraction < z <= 1.-fraction:
      return (fraction*her.iprofile/(her.iprofile+1.)+z-fraction)
    if 1. - fraction < z <= 1.:
      return (z - (fraction/(her.iprofile+1.))*(1.+power((z-1.)/fraction+1.,her.iprofile+1.)))
    if z > 1.: return (1.-2*fraction/(her.iprofile+1.))
  if lsamecharge:
    her.var[8,0] = 0.
    her.var[8,-1] = 1.
    for i in range (1,her.niz-1):
      lower = 0.
      upper = 1.
      target = fint(1.)*i/(her.niz-1.)
      while upper - lower > 1.e-12:
        guess = (upper+lower)/2.
        if fint(guess) > target: upper = guess
        else: lower = guess
      her.var[8,i] = (upper+lower)/2.
    her.var[8,:] = delzbeam * her.var[8,:]
    her.var[13,:-1] = top.ibeam*delzbeam*fint(1.)/(top.vbeam*(her.niz-1.))
  else:
    for i in range (her.niz):
      her.var[8,i] = i / (her.niz - 1.)
    if 0 < her.iprofile < 5:
      for i in range (her.niz-1):
        her.var[13,i] = fint(her.var[8,i+1])-fint(her.var[8,i])
    her.var[13,:] = her.var[13,:]*top.ibeam*delzbeam/top.vbeam
    her.var[8,:] = delzbeam * her.var[8,:]
  extebher(0.,top.dt,her.var,her.niz) # Needed to set up rpipe and therefore rmmax
  her.var[9,:] = top.vbeam / top.clight
  her.var[0,:] = top.rwall / 2. # For now
  her.var[1,:] = 0.             # For now
  her.var[2,:] = top.rwall / 2. # For now
  her.var[3,:] = 0.             # For now
  getradius(her.var,her.niz,her.rpipe,her.icharge)
  lfail = false
  setrhohr(her.niz,her.var,her.rpipe,her.icharge,lfail)
  if lfail:
    print "Error in setrhohr: Slice positions are not in increasing order"
    return
  getcurrent(her.var,her.niz,her.rpipe,her.icharge,her.lcurgrid,lfail)
  if lfail:
    print "Error in getcurrent: Slice positions are not in increasing order"
    return
  if top.emitn:
    her.var[10:12,:] = top.emitn * her.var[12,:] / top.ibeam
  else:
    gaminv = sqrt(1.-power(her.var[9,:],2))
    her.var[10:12,:] = (top.emit*gaminv/her.var[9,:]) * her.var[12,:] / top.ibeam
  if top.dt < 0.: her.var[8,:] = her.var[8,:] + top.zimin
  else: her.var[8,:] = her.var[8,:] - her.var[8,-1] + top.zimax
                        
def sethermesenvelope (niter = 1000, errorlimit = 1.e-9):
  """Matches the transverse envelope of all slice boundaries using WARP's envelope solver.
Before calling this routine, env.zl and env.zu should be set to
cover exactly one half lattice period. Also, env.dzenv should be set.
 - niter = 1000 : Maximum number of iterations.
 _ errorlimit = 1.e-9 : Criterion for convergence.
  """
  # --- Finds the matched conditions. Assumes a cigar load.
  her.var[4:8,:] = 0.    # Centroid motion not implemented in HERMES
  if not her.lcurgrid:
    her.var[:4,0]  = 0.    # First slice at zero (cigar load)
    her.var[:4,-1] = 0.    # Last slice also at zero (cigar load)
  # --- Save top variables
  ibeam = top.ibeam
  emit = top.emit
  ekin = top.ekin
  a0 = top.a0
  b0 = top.b0
  ap0 = top.ap0
  bp0 = top.bp0
  # --- Load env package
  package ("env"); generate();
  quadindex = searchsorted (top.quadzs,env.zl)
  top.ap0 = sign (top.ap0, -top.quadde[quadindex]+top.quaddb[quadindex]*top.vbeam)
  top.bp0 = - top.ap0
  # --- Calculate lattice half period
  lhp = env.zu - env.zl
  # --- Set up start and end of loop
  istart = 0
  iend = her.niz
  if not her.lcurgrid:
    istart = 1
    iend = her.niz-1
  # --- Start loop
  for i in range (istart,iend):
    # --- Load variables for this slice
    top.emit_s = 0.
    top.emitn = sqrt(her.var[10,i]*her.var[11,i])
    top.emit = top.emitn / (her.var[9,i]*top.gammabar)
    top.ibeam = her.var[12,i]
    # --- Recalculate stuff
    derivqty()
    envx()
    for counter in range(niter):
      top.a0  =  0.25*abs(env.aenv[0]+env.aenv[-1]+env.benv[0]+env.benv[-1])
      top.ap0 =  0.25*(env.apenv[0]-env.apenv[-1]-env.bpenv[0]+env.bpenv[-1])
      top.b0  =  top.a0
      top.bp0 = -top.ap0
      envx()
      error = abs(top.a0-env.aenv[-1]) 
      error = error + abs(top.b0-env.benv[-1])
      error = error + abs(top.ap0+env.apenv[-1])
      error = error + abs(top.bp0+env.bpenv[-1])
      if error < errorlimit:
        break
    if (error > errorlimit):
      print "Slice", i, ": After", niter, "steps"
      raise Exception("No convergence in sethermesenvelope")
    # --- Calculate the envelope value at the position of this slice
    zu = env.zu
    dz = env.dzenv
    env.zu = her.var[8,i]
    while env.zu < env.zl: env.zu = env.zu + 2. * lhp
    while env.zu > env.zl + 2. * lhp: env.zu = env.zu - 2. * lhp
    env.dzenv = (env.zu -env.zl) / env.nenv
    envx()
    env.zu = zu
    env.dzenv = dz
    # --- Save the results
    her.var[0,i] = env.aenv[-1]
    her.var[1,i] = env.apenv[-1]
    her.var[2,i] = env.benv[-1]
    her.var[3,i] = env.bpenv[-1]
  top.a0 = a0
  top.b0 = b0
  top.bp0 = bp0
  top.ibeam = ibeam
  top.emit_s = 0.
  top.emit = emit
  derivqty()
  envx()
  package ("her")
  top.nzl = top.nzlmax # This was reset by the env package

def hermeserrorcheck():
  """Checks for some inconsistencies in the Hermes flags."""
  if her.icharge != 7 and her.lcurgrid:
     raise Exception('In hermeserrorcheck. Error: Use her.lcurgrid=true only if her.icharge=7')
  if her.icharge != 7 and her.lezcenter:
     print 'In hermeserrorcheck. Warning: her.lezcenter is ignored if her.icharge is not 7'
  if her.lviscous and (not her.lezbeam):
     print 'In hermeserrorcheck. Warning: her.lviscous is ignored if her.lezbeam is false'

def doubleniz(oldvars):
  """This function doubles the number of slices used by Hermes, using interpolation to set up the new slices."""
  oldniz = shape(oldvars)[1]
  niz = 2*oldniz-1
  newvars = zeros((16,niz),'d')
  for variable in range(12):
    for slice in range(oldniz):
      newvars[variable,2*slice] = oldvars[variable,slice]
    for slice in range(1,niz,2):
      newvars[variable,slice] = (newvars[variable,slice-1]+newvars[variable,slice+1])/2.
  for variable in [12,14]:
    for slice in range(oldniz):
      newvars[variable,2*slice] = oldvars[variable,slice]
    for slice in range(1,niz,2):
      newvars[variable,slice] = (newvars[variable,slice-1]+newvars[variable,slice+1])/2.
  for slice in range(oldniz-1):
    newvars[13,2*slice]   = oldvars[13,slice] / 2.
    newvars[13,2*slice+1] = oldvars[13,slice] / 2.
  return newvars

def halfniz(oldvars):
  """This function divides the number of slices used by Hermes by two."""
  oldniz = shape(oldvars)[1]
  niz = (oldniz+1)/2
  newvars = zeros((16,niz),'d')
  for variable in range(12):
    for slice in range(niz):
      newvars[variable,slice] = oldvars[variable,2*slice]
  for variable in [12,14]:
    for slice in range(niz):
      newvars[variable,slice] = oldvars[variable,2*slice]
  for slice in range(niz-1):
    newvars[13,slice] = oldvars[13,2*slice] + oldvars[13,2*slice+1]
  return newvars

def readbessel():
  """This subroutine initializes some numerical values needed for the Bessel function."""
  her.besselzero[0] = 2.40482555769574668
  her.besselzero[1] = 5.52007811028631323
  her.besselzero[2] = 8.65372791311373212
  her.besselzero[3] = 11.7915344390570653
  her.besselzero[4] = 14.9309177085008819
  her.besselzero[5] = 18.0710639679159541
  her.besselzero[6] = 21.2116366298815162
  her.besselzero[7] = 24.3524715307504324
  her.besselzero[8] = 27.4934791320408722
  her.besselzero[9] = 30.6346064684323327
  her.besselzero[10] = 33.7758202135737883
  her.besselzero[11] = 36.9170983536641861
  her.besselzero[12] = 40.0584257646283337
  her.besselzero[13] = 43.1997917131767916
  her.besselzero[14] = 46.3411883716618611
  her.besselzero[15] = 49.4826098973978467
  her.besselzero[16] = 52.6240518411150226
  her.besselzero[17] = 55.7655107550199957
  her.besselzero[18] = 58.906983926080958
  her.besselzero[19] = 62.0484691902271823
  her.besselzero[20] = 65.1899648002068676
  her.besselzero[21] = 68.3314693298567998
  her.besselzero[22] = 71.4729816035937393
  her.besselzero[23] = 74.6145006437018487
  her.besselzero[24] = 77.7560256303880503
  her.besselzero[25] = 80.897555871137623
  her.besselzero[26] = 84.0390907769381989
  her.besselzero[27] = 87.180629843641153
  her.besselzero[28] = 90.3221726372104782
  her.besselzero[29] = 93.4637187819447845
  her.besselzero[30] = 96.6052679509962608
  her.besselzero[31] = 99.7468198586805954
  her.besselzero[32] = 102.888374254194792
  her.besselzero[33] = 106.029930917647763
  her.besselzero[34] = 109.171489650901198
  her.besselzero[35] = 112.313050281501314
  her.besselzero[36] = 115.454612654593402
  her.besselzero[37] = 118.596176631727301
  her.besselzero[38] = 121.73774208874124
  her.besselzero[39] = 124.879308913965081
  her.besselzero[40] = 128.020877006687872
  her.besselzero[41] = 131.162446275845789
  her.besselzero[42] = 134.304016638894041
  her.besselzero[43] = 137.445588020833375
  her.besselzero[44] = 140.587160353367401
  her.besselzero[45] = 143.728733574169931
  her.besselzero[46] = 146.870307626246692
  her.besselzero[47] = 150.01188245737711
  her.besselzero[48] = 153.153458019624792
  her.besselzero[49] = 156.295034268906967
  her.besselzero[50] = 159.436611164614934
  her.besselzero[51] = 162.578188669278445
  her.besselzero[52] = 165.719766748268293
  her.besselzero[53] = 168.861345369531923
  her.besselzero[54] = 172.002924503358372
  her.besselzero[55] = 175.144504122168109
  her.besselzero[56] = 178.286084200325367
  her.besselzero[57] = 181.427664713969782
  her.besselzero[58] = 184.569245640865489
  her.besselzero[59] = 187.710826960264931
  her.besselzero[60] = 190.8524086527866
  her.besselzero[61] = 193.993990700304408
  her.besselzero[62] = 197.135573085847504
  her.besselzero[63] = 200.277155793509908
  her.besselzero[64] = 203.418738808368049
  her.besselzero[65] = 206.560322116406247
  her.besselzero[66] = 209.701905704448687
  her.besselzero[67] = 212.843489560097332
  her.besselzero[68] = 215.985073671675475
  her.besselzero[69] = 219.126658028176057
  her.besselzero[70] = 222.26824261921414
  her.besselzero[71] = 225.409827434983833
  her.besselzero[72] = 228.55141246621824
  her.besselzero[73] = 231.692997704153125
  her.besselzero[74] = 234.834583140493347
  her.besselzero[75] = 237.976168767381413
  her.besselzero[76] = 241.117754577369769
  her.besselzero[77] = 244.259340563393489
  her.besselzero[78] = 247.400926718747005
  her.besselzero[79] = 250.54251303706061
  her.besselzero[80] = 253.684099512280392
  her.besselzero[81] = 256.825686138648645
  her.besselzero[82] = 259.967272910685665
  her.besselzero[83] = 263.108859823173757
  her.besselzero[84] = 266.250446871141432
  her.besselzero[85] = 269.392034049849016
  her.besselzero[86] = 272.533621354775368
  her.besselzero[87] = 275.67520878160554
  her.besselzero[88] = 278.816796326218874
  her.besselzero[89] = 281.958383984678562
  her.besselzero[90] = 285.09997175322109
  her.besselzero[91] = 288.241559628247259
  her.besselzero[92] = 291.383147606312888
  her.besselzero[93] = 294.52473568412083
  her.besselzero[94] = 297.666323858513024
  her.besselzero[95] = 300.807912126463516
  her.besselzero[96] = 303.949500485071366
  her.besselzero[97] = 307.091088931554256
  her.besselzero[98] = 310.232677463242723
  her.besselzero[99] = 313.374266077574192
  her.besselzero[100] = 316.515854772087923
  her.besselzero[101] = 319.65744354441985
  her.besselzero[102] = 322.799032392297968
  her.besselzero[103] = 325.940621313537892
  her.besselzero[104] = 329.082210306038547
  her.besselzero[105] = 332.223799367778571
  her.besselzero[106] = 335.365388496812011
  her.besselzero[107] = 338.506977691265253
  her.besselzero[108] = 341.64856694933392
  her.besselzero[109] = 344.790156269278824
  her.besselzero[110] = 347.931745649424106
  her.besselzero[111] = 351.073335088153593
  her.besselzero[112] = 354.21492458390853
  her.besselzero[113] = 357.356514135185054
  her.besselzero[114] = 360.498103740531528
  her.besselzero[115] = 363.639693398546759
  her.besselzero[116] = 366.781283107877253
  her.besselzero[117] = 369.922872867215701
  her.besselzero[118] = 373.064462675298713
  her.besselzero[119] = 376.206052530905221
  her.besselzero[120] = 379.347642432854659
  her.besselzero[121] = 382.489232380004793
  her.besselzero[122] = 385.63082237125128
  her.besselzero[123] = 388.772412405524914
  her.besselzero[124] = 391.91400248179109
  her.besselzero[125] = 395.055592599047997
  her.besselzero[126] = 398.19718275632546
  her.besselzero[127] = 401.338772952683608
  her.besselzero[128] = 404.480363187211988
  her.besselzero[129] = 407.621953459027874
  her.besselzero[130] = 410.763543767275951
  her.besselzero[131] = 413.905134111126482
  her.besselzero[132] = 417.046724489774867
  her.besselzero[133] = 420.188314902440929
  her.besselzero[134] = 423.329905348366875
  her.besselzero[135] = 426.471495826818003
  her.besselzero[136] = 429.613086337080751
  her.besselzero[137] = 432.754676878462163
  her.besselzero[138] = 435.89626745028962
  her.besselzero[139] = 439.037858051909335
  her.besselzero[140] = 442.179448682686437
  her.besselzero[141] = 445.32103934200391
  her.besselzero[142] = 448.462630029261877
  her.besselzero[143] = 451.604220743877071
  her.besselzero[144] = 454.745811485282835
  her.besselzero[145] = 457.887402252927611
  her.besselzero[146] = 461.028993046275026
  her.besselzero[147] = 464.170583864803099
  her.besselzero[148] = 467.312174708004057
  her.besselzero[149] = 470.453765575383542
  her.besselzero[150] = 473.595356466460515
  her.besselzero[151] = 476.736947380766551
  her.besselzero[152] = 479.878538317845304
  her.besselzero[153] = 483.020129277252419
  her.besselzero[154] = 486.161720258555085
  her.besselzero[155] = 489.303311261331597
  her.besselzero[156] = 492.444902285170904
  her.besselzero[157] = 495.586493329672528
  her.besselzero[158] = 498.728084394446025
  her.besselzero[159] = 501.869675479110632
  her.besselzero[160] = 505.011266583295181
  her.besselzero[161] = 508.152857706637561
  her.besselzero[162] = 511.294448848784721
  her.besselzero[163] = 514.436040009392048
  her.besselzero[164] = 517.577631188123454
  her.besselzero[165] = 520.719222384651025
  her.besselzero[166] = 523.860813598654395
  her.besselzero[167] = 527.00240482982128
  her.besselzero[168] = 530.143996077846146
  her.besselzero[169] = 533.285587342431544
  her.besselzero[170] = 536.427178623286149
  her.besselzero[171] = 539.568769920125923
  her.besselzero[172] = 542.710361232673399
  her.besselzero[173] = 545.851952560657061
  her.besselzero[174] = 548.993543903812142
  her.besselzero[175] = 552.13513526187965
  her.besselzero[176] = 555.276726634606454
  her.besselzero[177] = 558.418318021745108
  her.besselzero[178] = 561.559909423053671
  her.besselzero[179] = 564.7015008382958
  her.besselzero[180] = 567.843092267240212
  her.besselzero[181] = 570.984683709660689
  her.besselzero[182] = 574.126275165335986
  her.besselzero[183] = 577.267866634049831
  her.besselzero[184] = 580.409458115590304
  her.besselzero[185] = 583.551049609750283
  her.besselzero[186] = 586.692641116327262
  her.besselzero[187] = 589.834232635122557
  her.besselzero[188] = 592.975824165942189
  her.besselzero[189] = 596.117415708595999
  her.besselzero[190] = 599.259007262897736
  her.besselzero[191] = 602.400598828665323
  her.besselzero[192] = 605.542190405720237
  her.besselzero[193] = 608.683781993887684
  her.besselzero[194] = 611.825373592996424
  her.besselzero[195] = 614.966965202878945
  her.besselzero[196] = 618.108556823370935
  her.besselzero[197] = 621.250148454311279
  her.besselzero[198] = 624.391740095542591
  her.besselzero[199] = 627.533331746909972
  her.besselzero[200] = 630.674923408262078
  her.besselzero[201] = 633.816515079450493
  her.besselzero[202] = 636.958106760329556
  her.besselzero[203] = 640.099698450756715
  her.besselzero[204] = 643.241290150591993
  her.besselzero[205] = 646.382881859698255
  her.besselzero[206] = 649.52447357794103
  her.besselzero[207] = 652.666065305188158
  her.besselzero[208] = 655.80765704131041
  her.besselzero[209] = 658.949248786180863
  her.besselzero[210] = 662.090840539674907
  her.besselzero[211] = 665.232432301670417
  her.besselzero[212] = 668.374024072047667
  her.besselzero[213] = 671.515615850688618
  her.besselzero[214] = 674.657207637478251
  her.besselzero[215] = 677.798799432302967
  her.besselzero[216] = 680.940391235051656
  her.besselzero[217] = 684.081983045615249
  her.besselzero[218] = 687.223574863886454
  her.besselzero[219] = 690.365166689760023
  her.besselzero[220] = 693.506758523132749
  her.besselzero[221] = 696.648350363903112
  her.besselzero[222] = 699.789942211971371
  her.besselzero[223] = 702.931534067239915
  her.besselzero[224] = 706.073125929612466
  her.besselzero[225] = 709.214717798994609
  her.besselzero[226] = 712.356309675293886
  her.besselzero[227] = 715.497901558418725
  her.besselzero[228] = 718.639493448280042
  her.besselzero[229] = 721.781085344789552
  her.besselzero[230] = 724.922677247861013
  her.besselzero[231] = 728.064269157409249
  her.besselzero[232] = 731.205861073351126
  her.besselzero[233] = 734.34745299560431
  her.besselzero[234] = 737.489044924088421
  her.besselzero[235] = 740.630636858723789
  her.besselzero[236] = 743.772228799432788
  her.besselzero[237] = 746.91382074613859
  her.besselzero[238] = 750.055412698765877
  her.besselzero[239] = 753.197004657240665
  her.besselzero[240] = 756.338596621489944
  her.besselzero[241] = 759.480188591442129
  her.besselzero[242] = 762.621780567026785
  her.besselzero[243] = 765.763372548174459
  her.besselzero[244] = 768.904964534817203
  her.besselzero[245] = 772.046556526887695
  her.besselzero[246] = 775.18814852432003
  her.besselzero[247] = 778.329740527049285
  her.besselzero[248] = 781.471332535011509
  her.besselzero[249] = 784.612924548143997
  her.besselzero[250] = 787.754516566384666
  her.besselzero[251] = 790.896108589672941
  her.besselzero[252] = 794.037700617948694
  her.besselzero[253] = 797.179292651153126
  her.besselzero[254] = 800.320884689227973
  her.besselzero[255] = 803.462476732116215
  her.besselzero[256] = 806.60406877976154
  her.besselzero[257] = 809.745660832108704
  her.besselzero[258] = 812.887252889103351
  her.besselzero[259] = 816.028844950691123
  her.besselzero[260] = 819.170437016819974
  her.besselzero[261] = 822.312029087437679
  her.besselzero[262] = 825.453621162492723
  her.besselzero[263] = 828.59521324193448
  her.besselzero[264] = 831.736805325713746
  her.besselzero[265] = 834.878397413781314
  her.besselzero[266] = 838.019989506088869
  her.besselzero[267] = 841.161581602588981
  her.besselzero[268] = 844.303173703234932
  her.besselzero[269] = 847.444765807980715
  her.besselzero[270] = 850.586357916780499
  her.besselzero[271] = 853.727950029589877
  her.besselzero[272] = 856.869542146364615
  her.besselzero[273] = 860.011134267061194
  her.besselzero[274] = 863.152726391636981
  her.besselzero[275] = 866.294318520049522
  her.besselzero[276] = 869.435910652257604
  her.besselzero[277] = 872.577502788219838
  her.besselzero[278] = 875.71909492789608
  her.besselzero[279] = 878.860687071246182
  her.besselzero[280] = 882.002279218231421
  her.besselzero[281] = 885.14387136881254
  her.besselzero[282] = 888.285463522951701
  her.besselzero[283] = 891.427055680611246
  her.besselzero[284] = 894.568647841754049
  her.besselzero[285] = 897.710240006343518
  her.besselzero[286] = 900.851832174343769
  her.besselzero[287] = 903.993424345718743
  her.besselzero[288] = 907.135016520433978
  her.besselzero[289] = 910.276608698454658
  her.besselzero[290] = 913.4182008797465
  her.besselzero[291] = 916.559793064276107
  her.besselzero[292] = 919.701385252010439
  her.besselzero[293] = 922.842977442916279
  her.besselzero[294] = 925.984569636961651
  her.besselzero[295] = 929.126161834114761
  her.besselzero[296] = 932.267754034343987
  her.besselzero[297] = 935.409346237618422
  her.besselzero[298] = 938.550938443907689
  her.besselzero[299] = 941.692530653181236
  her.besselzero[300] = 944.834122865409575
  her.besselzero[301] = 947.975715080563396
  her.besselzero[302] = 951.11730729861339
  her.besselzero[303] = 954.258899519531134
  her.besselzero[304] = 957.400491743288384
  her.besselzero[305] = 960.542083969857252
  her.besselzero[306] = 963.683676199210381
  her.besselzero[307] = 966.825268431320594
  her.besselzero[308] = 969.96686066616089
  her.besselzero[309] = 973.108452903705156
  her.besselzero[310] = 976.250045143926925
  her.besselzero[311] = 979.391637386800795
  her.besselzero[312] = 982.53322963230083
  her.besselzero[313] = 985.674821880402518
  her.besselzero[314] = 988.816414131080634
  her.besselzero[315] = 991.958006384311019
  her.besselzero[316] = 995.099598640068983
  her.besselzero[317] = 998.241190898331254
  her.besselzero[318] = 1001.38278315907403
  her.besselzero[319] = 1004.5243754222739
  her.besselzero[320] = 1007.66596768790783
  her.besselzero[321] = 1010.80755995595361
  her.besselzero[322] = 1013.94915222638859
  her.besselzero[323] = 1017.09074449919012
  her.besselzero[324] = 1020.23233677433688
  her.besselzero[325] = 1023.37392905180735
  her.besselzero[326] = 1026.51552133157997
  her.besselzero[327] = 1029.65711361363365
  her.besselzero[328] = 1032.79870589794775
  her.besselzero[329] = 1035.94029818450117
  her.besselzero[330] = 1039.08189047327437
  her.besselzero[331] = 1042.22348276424692
  her.besselzero[332] = 1045.36507505739884
  her.besselzero[333] = 1048.50666735271058
  her.besselzero[334] = 1051.64825965016306
  her.besselzero[335] = 1054.78985194973695
  her.besselzero[336] = 1057.93144425141316
  her.besselzero[337] = 1061.07303655517348
  her.besselzero[338] = 1064.21462886099926
  her.besselzero[339] = 1067.35622116887229
  her.besselzero[340] = 1070.49781347877415
  her.besselzero[341] = 1073.6394057906875
  her.besselzero[342] = 1076.78099810459459
  her.besselzero[343] = 1079.92259042047811
  her.besselzero[344] = 1083.06418273832072
  her.besselzero[345] = 1086.20577505810533
  her.besselzero[346] = 1089.34736737981507
  her.besselzero[347] = 1092.48895970343395
  her.besselzero[348] = 1095.6305520289451
  her.besselzero[349] = 1098.77214435633231
  her.besselzero[350] = 1101.91373668557934
  her.besselzero[351] = 1105.05532901667069
  her.besselzero[352] = 1108.19692134959035
  her.besselzero[353] = 1111.33851368432323
  her.besselzero[354] = 1114.48010602085356
  her.besselzero[355] = 1117.62169835916624
  her.besselzero[356] = 1120.76329069924685
  her.besselzero[357] = 1123.90488304108004
  her.besselzero[358] = 1127.04647538465119
  her.besselzero[359] = 1130.18806772994562
  her.besselzero[360] = 1133.32966007694913
  her.besselzero[361] = 1136.47125242564817
  her.besselzero[362] = 1139.61284477602786
  her.besselzero[363] = 1142.75443712807489
  her.besselzero[364] = 1145.89602948177526
  her.besselzero[365] = 1149.03762183711544
  her.besselzero[366] = 1152.17921419408209
  her.besselzero[367] = 1155.32080655266189
  her.besselzero[368] = 1158.46239891284175
  her.besselzero[369] = 1161.60399127460856
  her.besselzero[370] = 1164.74558363794966
  her.besselzero[371] = 1167.88717600285241
  her.besselzero[372] = 1171.02876836930414
  her.besselzero[373] = 1174.17036073729219
  her.besselzero[374] = 1177.31195310680458
  her.besselzero[375] = 1180.4535454778291
  her.besselzero[376] = 1183.5951378503533
  her.besselzero[377] = 1186.73673022436609
  her.besselzero[378] = 1189.87832259985504
  her.besselzero[379] = 1193.01991497680837
  her.besselzero[380] = 1196.16150735521497
  her.besselzero[381] = 1199.30309973506332
  her.besselzero[382] = 1202.44469211634208
  her.besselzero[383] = 1205.58628449903992
  her.besselzero[384] = 1208.7278768831462
  her.besselzero[385] = 1211.86946926864935
  her.besselzero[386] = 1215.01106165553895
  her.besselzero[387] = 1218.15265404380435
  her.besselzero[388] = 1221.29424643343442
  her.besselzero[389] = 1224.43583882441897
  her.besselzero[390] = 1227.577431216748
  her.besselzero[391] = 1230.71902361041063
  her.besselzero[392] = 1233.86061600539687
  her.besselzero[393] = 1237.00220840169694
  her.besselzero[394] = 1240.14380079930019
  her.besselzero[395] = 1243.2853931981973
  her.besselzero[396] = 1246.42698559837827
  her.besselzero[397] = 1249.56857799983334
  her.besselzero[398] = 1252.71017040255316
  her.besselzero[399] = 1255.85176280652799
  her.besselzero[400] = 1258.99335521174893
  her.besselzero[401] = 1262.13494761820577
  her.besselzero[402] = 1265.27654002589029
  her.besselzero[403] = 1268.41813243479273
  her.besselzero[404] = 1271.5597248449042
  her.besselzero[405] = 1274.70131725621582
  her.besselzero[406] = 1277.84290966871871
  her.besselzero[407] = 1280.98450208240421
  her.besselzero[408] = 1284.12609449726344
  her.besselzero[409] = 1287.26768691328796
  her.besselzero[410] = 1290.40927933046933
  her.besselzero[411] = 1293.55087174879868
  her.besselzero[412] = 1296.69246416826844
  her.besselzero[413] = 1299.83405658886974
  her.besselzero[414] = 1302.97564901059437
  her.besselzero[415] = 1306.11724143343455
  her.besselzero[416] = 1309.25883385738228
  her.besselzero[417] = 1312.40042628242914
  her.besselzero[418] = 1315.54201870856757
  her.besselzero[419] = 1318.68361113579002
  her.besselzero[420] = 1321.82520356408828
  her.besselzero[421] = 1324.96679599345457
  her.besselzero[422] = 1328.10838842388223
  her.besselzero[423] = 1331.24998085536305
  her.besselzero[424] = 1334.39157328788948
  her.besselzero[425] = 1337.53316572145442
  her.besselzero[426] = 1340.67475815605052
  her.besselzero[427] = 1343.81635059167092
  her.besselzero[428] = 1346.95794302830762
  her.besselzero[429] = 1350.09953546595418
  her.besselzero[430] = 1353.24112790460349
  her.besselzero[431] = 1356.382720344248
  her.besselzero[432] = 1359.52431278488172
  her.besselzero[433] = 1362.66590522649733
  her.besselzero[434] = 1365.80749766908793
  her.besselzero[435] = 1368.94909011264709
  her.besselzero[436] = 1372.09068255716792
  her.besselzero[437] = 1375.232275002644
  her.besselzero[438] = 1378.37386744906886
  her.besselzero[439] = 1381.51545989643587
  her.besselzero[440] = 1384.65705234473857
  her.besselzero[441] = 1387.79864479397074
  her.besselzero[442] = 1390.94023724412597
  her.besselzero[443] = 1394.08182969519822
  her.besselzero[444] = 1397.22342214718109
  her.besselzero[445] = 1400.36501460006856
  her.besselzero[446] = 1403.50660705385443
  her.besselzero[447] = 1406.6481995085331
  her.besselzero[448] = 1409.78979196409799
  her.besselzero[449] = 1412.9313844205436
  her.besselzero[450] = 1416.0729768778637
  her.besselzero[451] = 1419.21456933605298
  her.besselzero[452] = 1422.35616179510548
  her.besselzero[453] = 1425.49775425501534
  her.besselzero[454] = 1428.63934671577696
  her.besselzero[455] = 1431.78093917738502
  her.besselzero[456] = 1434.92253163983329
  her.besselzero[457] = 1438.06412410311672
  her.besselzero[458] = 1441.20571656723033
  her.besselzero[459] = 1444.3473090321679
  her.besselzero[460] = 1447.48890149792437
  her.besselzero[461] = 1450.63049396449432
  her.besselzero[462] = 1453.77208643187261
  her.besselzero[463] = 1456.91367890005407
  her.besselzero[464] = 1460.05527136903339
  her.besselzero[465] = 1463.19686383880531
  her.besselzero[466] = 1466.33845630936487
  her.besselzero[467] = 1469.48004878070719
  her.besselzero[468] = 1472.62164125282701
  her.besselzero[469] = 1475.76323372571955
  her.besselzero[470] = 1478.90482619937984
  her.besselzero[471] = 1482.04641867380315
  her.besselzero[472] = 1485.18801114898391
  her.besselzero[473] = 1488.3296036249181
  her.besselzero[474] = 1491.4711961016005
  her.besselzero[475] = 1494.61278857902657
  her.besselzero[476] = 1497.75438105719205
  her.besselzero[477] = 1500.89597353609178
  her.besselzero[478] = 1504.03756601572098
  her.besselzero[479] = 1507.17915849607582
  her.besselzero[480] = 1510.32075097715123
  her.besselzero[481] = 1513.46234345894288
  her.besselzero[482] = 1516.60393594144604
  her.besselzero[483] = 1519.74552842465682
  her.besselzero[484] = 1522.88712090857014
  her.besselzero[485] = 1526.0287133931822
  her.besselzero[486] = 1529.17030587848863
  her.besselzero[487] = 1532.31189836448544
  her.besselzero[488] = 1535.45349085116766
  her.besselzero[489] = 1538.59508333853174
  her.besselzero[490] = 1541.73667582657287
  her.besselzero[491] = 1544.87826831528751
  her.besselzero[492] = 1548.01986080467157
  her.besselzero[493] = 1551.16145329472061
  her.besselzero[494] = 1554.30304578543054
  her.besselzero[495] = 1557.44463827679791
  her.besselzero[496] = 1560.58623076881808
  her.besselzero[497] = 1563.72782326148795
  her.besselzero[498] = 1566.86941575480265
  her.besselzero[499] = 1570.01100824875887
  her.besselzero[500] = 1573.15260074335299
  her.besselzero[501] = 1576.29419323858037
  her.besselzero[502] = 1579.4357857344381
  her.besselzero[503] = 1582.57737823092181
  her.besselzero[504] = 1585.71897072802814
  her.besselzero[505] = 1588.86056322575335
  her.besselzero[506] = 1592.0021557240938
  her.besselzero[507] = 1595.14374822304549
  her.besselzero[508] = 1598.28534072260541
  her.besselzero[509] = 1601.42693322276912
  her.besselzero[510] = 1604.56852572353403
  her.besselzero[511] = 1607.71011822489606
  her.besselzero[512] = 1610.85171072685229
  her.besselzero[513] = 1613.99330322939853
  her.besselzero[514] = 1617.13489573253133
  her.besselzero[515] = 1620.27648823624792
  her.besselzero[516] = 1623.4180807405445
  her.besselzero[517] = 1626.55967324541776
  her.besselzero[518] = 1629.70126575086453
  her.besselzero[519] = 1632.84285825688124
  her.besselzero[520] = 1635.98445076346443
  her.besselzero[521] = 1639.12604327061162
  her.besselzero[522] = 1642.26763577831853
  her.besselzero[523] = 1645.40922828658331
  her.besselzero[524] = 1648.55082079540116
  her.besselzero[525] = 1651.69241330477012
  her.besselzero[526] = 1654.83400581468664
  her.besselzero[527] = 1657.97559832514762
  her.besselzero[528] = 1661.11719083615021
  her.besselzero[529] = 1664.2587833476905
  her.besselzero[530] = 1667.40037585976663
  her.besselzero[531] = 1670.54196837237505
  her.besselzero[532] = 1673.68356088551228
  her.besselzero[533] = 1676.82515339917621
  her.besselzero[534] = 1679.96674591336336
  her.besselzero[535] = 1683.10833842807099
  her.besselzero[536] = 1686.24993094329544
  her.besselzero[537] = 1689.39152345903558
  her.besselzero[538] = 1692.53311597528677
  her.besselzero[539] = 1695.67470849204688
  her.besselzero[540] = 1698.81630100931317
  her.besselzero[541] = 1701.95789352708288
  her.besselzero[542] = 1705.09948604535281
  her.besselzero[543] = 1708.24107856412084
  her.besselzero[544] = 1711.38267108338348
  her.besselzero[545] = 1714.52426360313836
  her.besselzero[546] = 1717.66585612338325
  her.besselzero[547] = 1720.8074486441145
  her.besselzero[548] = 1723.94904116533043
  her.besselzero[549] = 1727.09063368702757
  her.besselzero[550] = 1730.23222620920407
  her.besselzero[551] = 1733.37381873185663
  her.besselzero[552] = 1736.51541125498276
  her.besselzero[553] = 1739.65700377858034
  her.besselzero[554] = 1742.79859630264644
  her.besselzero[555] = 1745.94018882717927
  her.besselzero[556] = 1749.08178135217511
  her.besselzero[557] = 1752.22337387763182
  her.besselzero[558] = 1755.36496640354755
  her.besselzero[559] = 1758.5065589299198
  her.besselzero[560] = 1761.64815145674547
  her.besselzero[561] = 1764.78974398402215
  her.besselzero[562] = 1767.93133651174798
  her.besselzero[563] = 1771.0729290399203
  her.besselzero[564] = 1774.21452156853725
  her.besselzero[565] = 1777.35611409759535
  her.besselzero[566] = 1780.49770662709283
  her.besselzero[567] = 1783.63929915702819
  her.besselzero[568] = 1786.78089168739751
  her.besselzero[569] = 1789.92248421819999
  her.besselzero[570] = 1793.0640767494328
  her.besselzero[571] = 1796.20566928109326
  her.besselzero[572] = 1799.34726181317961
  her.besselzero[573] = 1802.48885434568961
  her.besselzero[574] = 1805.63044687862053
  her.besselzero[575] = 1808.77203941197102
  her.besselzero[576] = 1811.9136319457386
  her.besselzero[577] = 1815.05522447992078
  her.besselzero[578] = 1818.19681701451507
  her.besselzero[579] = 1821.33840954952077
  her.besselzero[580] = 1824.48000208493397
  her.besselzero[581] = 1827.62159462075395
  her.besselzero[582] = 1830.76318715697823
  her.besselzero[583] = 1833.90477969360432
  her.besselzero[584] = 1837.04637223063045
  her.besselzero[585] = 1840.18796476805448
  her.besselzero[586] = 1843.32955730587499
  her.besselzero[587] = 1846.47114984408915
  her.besselzero[588] = 1849.61274238269517
  her.besselzero[589] = 1852.75433492169128
  her.besselzero[590] = 1855.89592746107499
  her.besselzero[591] = 1859.03752000084487
  her.besselzero[592] = 1862.17911254099917
  her.besselzero[593] = 1865.32070508153502
  her.besselzero[594] = 1868.46229762245137
  her.besselzero[595] = 1871.60389016374608
  her.besselzero[596] = 1874.74548270541667
  her.besselzero[597] = 1877.88707524746243
  her.besselzero[598] = 1881.02866778988015
  her.besselzero[599] = 1884.17026033266878
  her.besselzero[600] = 1887.31185287582619
  her.besselzero[601] = 1890.45344541935094
  her.besselzero[602] = 1893.59503796324091
  her.besselzero[603] = 1896.73663050749397
  her.besselzero[604] = 1899.87822305210904
  her.besselzero[605] = 1903.0198155970833
  her.besselzero[606] = 1906.16140814241603
  her.besselzero[607] = 1909.30300068810474
  her.besselzero[608] = 1912.44459323414801
  her.besselzero[609] = 1915.58618578054442
  her.besselzero[610] = 1918.72777832729148
  her.besselzero[611] = 1921.86937087438813
  her.besselzero[612] = 1925.01096342183188
  her.besselzero[613] = 1928.15255596962202
  her.besselzero[614] = 1931.29414851775607
  her.besselzero[615] = 1934.43574106623294
  her.besselzero[616] = 1937.57733361505017
  her.besselzero[617] = 1940.71892616420704
  her.besselzero[618] = 1943.86051871370142
  her.besselzero[619] = 1947.00211126353153
  her.besselzero[620] = 1950.1437038136963
  her.besselzero[621] = 1953.28529636419325
  her.besselzero[622] = 1956.42688891502167
  her.besselzero[623] = 1959.56848146617943
  her.besselzero[624] = 1962.7100740176651
  her.besselzero[625] = 1965.85166656947691
  her.besselzero[626] = 1968.99325912161415
  her.besselzero[627] = 1972.13485167407398
  her.besselzero[628] = 1975.27644422685568
  her.besselzero[629] = 1978.41803677995748
  her.besselzero[630] = 1981.55962933337832
  her.besselzero[631] = 1984.70122188711606
  her.besselzero[632] = 1987.84281444116928
  her.besselzero[633] = 1990.98440699553655
  her.besselzero[634] = 1994.12599955021683
  her.besselzero[635] = 1997.26759210520796
  her.besselzero[636] = 2000.40918466050854
  her.besselzero[637] = 2003.5507772161174
  her.besselzero[638] = 2006.69236977203357
  her.besselzero[639] = 2009.83396232825484
  her.besselzero[640] = 2012.97555488477986
  her.besselzero[641] = 2016.11714744160774
  her.besselzero[642] = 2019.25873999873628
  her.besselzero[643] = 2022.40033255616458
  her.besselzero[644] = 2025.5419251138913
  her.besselzero[645] = 2028.68351767191512
  her.besselzero[646] = 2031.82511023023426
  her.besselzero[647] = 2034.96670278884783
  her.besselzero[648] = 2038.10829534775361
  her.besselzero[649] = 2041.24988790695116
  her.besselzero[650] = 2044.3914804664387
  her.besselzero[651] = 2047.53307302104481
  her.besselzero[652] = 2050.67466559137612
  her.besselzero[653] = 2053.81625814162571
  her.besselzero[654] = 2056.95785071219594
  her.besselzero[655] = 2060.09944326334082
  her.besselzero[656] = 2063.24103583415485
  her.besselzero[657] = 2066.38262838618036
  her.besselzero[658] = 2069.52422095724308
  her.besselzero[659] = 2072.6658135101319
  her.besselzero[660] = 2075.80740608144953
  her.besselzero[661] = 2078.94899863518789
  her.besselzero[662] = 2082.09059120676398
  her.besselzero[663] = 2085.23218376133723
  her.besselzero[664] = 2088.37377633317711
  her.besselzero[665] = 2091.51536888857014
  her.besselzero[666] = 2094.65696146067825
  her.besselzero[667] = 2097.7985540168782
  her.besselzero[668] = 2100.94014658925809
  her.besselzero[669] = 2104.08173914625029
  her.besselzero[670] = 2107.22333171890552
  her.besselzero[671] = 2110.36492427667798
  her.besselzero[672] = 2113.50651684961299
  her.besselzero[673] = 2116.64810940815373
  her.besselzero[674] = 2119.78970198137073
  her.besselzero[675] = 2122.93129454065709
  her.besselzero[676] = 2126.07288711414366
  her.besselzero[677] = 2129.21447967418142
  her.besselzero[678] = 2132.35607224805034
  her.besselzero[679] = 2135.49766480893854
  her.besselzero[680] = 2138.63925738282256
  her.besselzero[681] = 2141.78084994312856
  her.besselzero[682] = 2144.92244251559061
  her.besselzero[683] = 2148.06403507816234
  her.besselzero[684] = 2151.20562765825917
  her.besselzero[685] = 2154.34722021581137
  her.besselzero[686] = 2157.48881279603121
  her.besselzero[687] = 2160.63040535444139
  her.besselzero[688] = 2163.77199793479269
  her.besselzero[689] = 2166.91359049404397
  her.besselzero[690] = 2170.05518307453337
  her.besselzero[691] = 2173.19677563461111
  her.besselzero[692] = 2176.33836821524573
  her.besselzero[693] = 2179.47996077613392
  her.besselzero[694] = 2182.62155335692131
  her.besselzero[695] = 2185.76314591860576
  her.besselzero[696] = 2188.90473849955125
  her.besselzero[697] = 2192.04633106201685
  her.besselzero[698] = 2195.18792364312664
  her.besselzero[699] = 2198.32951620636007
  her.besselzero[700] = 2201.47110878764085
  her.besselzero[701] = 2204.61270135162745
  her.besselzero[702] = 2207.75429393308453
  her.besselzero[703] = 2210.89588649781143
  her.besselzero[704] = 2214.03747907945014
  her.besselzero[705] = 2217.17907164490402
  her.besselzero[706] = 2220.32066422672924
  her.besselzero[707] = 2223.46225679289766
  her.besselzero[708] = 2226.60384937491429
  her.besselzero[709] = 2229.74544194178481
  her.besselzero[710] = 2232.88703452399861
  her.besselzero[711] = 2236.02862709156102
  her.besselzero[712] = 2239.17021967397378
  her.besselzero[713] = 2242.31181224220588
  her.besselzero[714] = 2245.45340482480693
  her.besselzero[715] = 2248.59499739371626
  her.besselzero[716] = 2251.73658997662062
  her.besselzero[717] = 2254.87818254630711
  her.besselzero[718] = 2258.01977512914309
  her.besselzero[719] = 2261.16136769815545
  her.besselzero[720] = 2264.30296027946464
  her.besselzero[721] = 2267.4445528506939
  her.besselzero[722] = 2270.58614543967074
  her.besselzero[723] = 2273.7277380057228
  her.besselzero[724] = 2276.86933059474405
  her.besselzero[725] = 2280.01092316158526
  her.besselzero[726] = 2283.15251575065936
  her.besselzero[727] = 2286.29410831827417
  her.besselzero[728] = 2289.43570090741044
  her.besselzero[729] = 2292.57729347578376
  her.besselzero[730] = 2295.71888606498841
  her.besselzero[731] = 2298.86047863410647
  her.besselzero[732] = 2302.00207122338884
  her.besselzero[733] = 2305.14366379323654
  her.besselzero[734] = 2308.28525638260284
  her.besselzero[735] = 2311.42684895316685
  her.besselzero[736] = 2314.56844154262464
  her.besselzero[737] = 2317.71003411389164
  her.besselzero[738] = 2320.85162670344757
  her.besselzero[739] = 2323.9932192754038
  her.besselzero[740] = 2327.1348118650641
  her.besselzero[741] = 2330.27640443769801
  her.besselzero[742] = 2333.41799702746888
  her.besselzero[743] = 2336.55958960076759
  her.besselzero[744] = 2339.70118219065525
  her.besselzero[745] = 2342.84277476460633
  her.besselzero[746] = 2345.98436735461657
  her.besselzero[747] = 2349.12595992920802
  her.besselzero[748] = 2352.26755251934438
  her.besselzero[749] = 2355.40914509456555
  her.besselzero[750] = 2358.55073768484402
  her.besselzero[751] = 2361.69233026070068
  her.besselzero[752] = 2364.83392285110616
  her.besselzero[753] = 2367.97551542747308
  her.besselzero[754] = 2371.11710801789632
  her.besselzero[755] = 2374.25870059514831
  her.besselzero[756] = 2377.40029318707968
  her.besselzero[757] = 2380.54188576671421
  her.besselzero[758] = 2383.68347835716676
  her.besselzero[759] = 2386.82507092970919
  her.besselzero[760] = 2389.96666352628661
  her.besselzero[761] = 2393.10825609957955
  her.besselzero[762] = 2396.24984869613744
  her.besselzero[763] = 2399.39144127016357
  her.besselzero[764] = 2402.53303386671035
  her.besselzero[765] = 2405.6746264414559
  her.besselzero[766] = 2408.81621903800091
  her.besselzero[767] = 2411.95781161345168
  her.besselzero[768] = 2415.09940421000424
  her.besselzero[769] = 2418.24099678614512
  her.besselzero[770] = 2421.38258938271277
  her.besselzero[771] = 2424.52418195953134
  her.besselzero[772] = 2427.66577455612253
  her.besselzero[773] = 2430.80736713360412
  her.besselzero[774] = 2433.94895973022684
  her.besselzero[775] = 2437.09055230835991
  her.besselzero[776] = 2440.23214490502082
  her.besselzero[777] = 2443.37373748379205
  her.besselzero[778] = 2446.51533008049915
  her.besselzero[779] = 2449.65692265989565
  her.besselzero[780] = 2452.79851525665559
  her.besselzero[781] = 2455.94010783666671
  her.besselzero[782] = 2459.08170043348572
  her.besselzero[783] = 2462.22329301409947
  her.besselzero[784] = 2465.36488561098465
  her.besselzero[785] = 2468.50647819219082
  her.besselzero[786] = 2471.64807078914749
  her.besselzero[787] = 2474.78966337092476
  her.besselzero[788] = 2477.93125596794094
  her.besselzero[789] = 2481.07284855029863
  her.besselzero[790] = 2484.21444114749956
  her.besselzero[791] = 2487.3560337305447
  her.besselzero[792] = 2490.49762632753513
  her.besselzero[793] = 2493.63921890972406
  her.besselzero[794] = 2496.78081150495057
  her.besselzero[795] = 2499.92240408936527
  her.besselzero[796] = 2503.06399669262891
  her.besselzero[797] = 2506.20558927138947
  her.besselzero[798] = 2509.34718187456784
  her.besselzero[799] = 2512.4887744540354
  her.besselzero[800] = 2515.63036705713738
  her.besselzero[801] = 2518.77195963729638
  her.besselzero[802] = 2521.91355224033308
  her.besselzero[803] = 2525.05514482116888
  her.besselzero[804] = 2528.19673742415051
  her.besselzero[805] = 2531.33833000564845
  her.besselzero[806] = 2534.47992260858434
  her.besselzero[807] = 2537.62151519073153
  her.besselzero[808] = 2540.76310779362968
  her.besselzero[809] = 2543.90470037641236
  her.besselzero[810] = 2547.04629297928253
  her.besselzero[811] = 2550.18788556268738
  her.besselzero[812] = 2553.32947816553801
  her.besselzero[813] = 2556.47107074955304
  her.besselzero[814] = 2559.61266335239168
  her.besselzero[815] = 2562.75425593700356
  her.besselzero[816] = 2565.89584853983776
  her.besselzero[817] = 2569.03744112503584
  her.besselzero[818] = 2572.17903372787404
  her.besselzero[819] = 2575.32062631364544
  her.besselzero[820] = 2578.46221891649429
  her.besselzero[821] = 2581.6038115028288
  her.besselzero[822] = 2584.74540410569542
  her.besselzero[823] = 2587.88699669258326
  her.besselzero[824] = 2591.02858929547341
  her.besselzero[825] = 2594.17018188289238
  her.besselzero[826] = 2597.3117744857963
  her.besselzero[827] = 2600.45336707375662
  her.besselzero[828] = 2603.59495967679865
  her.besselzero[829] = 2606.73655226541223
  her.besselzero[830] = 2609.87814486819269
  her.besselzero[831] = 2613.01973745588611
  her.besselzero[832] = 2616.16133005682449
  her.besselzero[833] = 2619.30292264673525
  her.besselzero[834] = 2622.44451525580668
  her.besselzero[835] = 2625.58610783991719
  her.besselzero[836] = 2628.7277004488545
  her.besselzero[837] = 2631.86929303363692
  her.besselzero[838] = 2635.01088564245167
  her.besselzero[839] = 2638.15247822789222
  her.besselzero[840] = 2641.29407083659462
  her.besselzero[841] = 2644.43566342267866
  her.besselzero[842] = 2647.57725603128069
  her.besselzero[843] = 2650.71884861799267
  her.besselzero[844] = 2653.86044122650321
  her.besselzero[845] = 2657.00203381383071
  her.besselzero[846] = 2660.14362642225998
  her.besselzero[847] = 2663.28521901018921
  her.besselzero[848] = 2666.42681161854611
  her.besselzero[849] = 2669.56840420706509
  her.besselzero[850] = 2672.70999681535847
  her.besselzero[851] = 2675.85158940445477
  her.besselzero[852] = 2678.9931820126922
  her.besselzero[853] = 2682.13477460235383
  her.besselzero[854] = 2685.27636721054552
  her.besselzero[855] = 2688.41795980076003
  her.besselzero[856] = 2691.55955240891264
  her.besselzero[857] = 2694.70114499966939
  her.besselzero[858] = 2697.84273760779047
  her.besselzero[859] = 2700.9843301990779
  her.besselzero[860] = 2704.12592280717589
  her.besselzero[861] = 2707.26751539898602
  her.besselzero[862] = 2710.40910800706669
  her.besselzero[863] = 2713.55070059937641
  her.besselzero[864] = 2716.6922932074291
  her.besselzero[865] = 2719.83388580024953
  her.besselzero[866] = 2722.97547840840348
  her.besselzero[867] = 2726.11707100184741
  her.besselzero[868] = 2729.25866360969582
  her.besselzero[869] = 2732.40025620216231
  her.besselzero[870] = 2735.54184880809536
  her.besselzero[871] = 2738.68344140278008
  her.besselzero[872] = 2741.82503401695498
  her.besselzero[873] = 2744.9666266056929
  her.besselzero[874] = 2748.10821921969283
  her.besselzero[875] = 2751.24981180907646
  her.besselzero[876] = 2754.3914044229143
  her.besselzero[877] = 2757.53299701292808
  her.besselzero[878] = 2760.6745896266136
  her.besselzero[879] = 2763.81618221724334
  her.besselzero[880] = 2766.95777483078808
  her.besselzero[881] = 2770.09936742202089
  her.besselzero[882] = 2773.24096003543507
  her.besselzero[883] = 2776.38255262725586
  her.besselzero[884] = 2779.52414524055013
  her.besselzero[885] = 2782.6657378329469
  her.besselzero[886] = 2785.8073304461306
  her.besselzero[887] = 2788.94892303909047
  her.besselzero[888] = 2792.09051565217292
  her.besselzero[889] = 2795.23210824568391
  her.besselzero[890] = 2798.37370085867398
  her.besselzero[891] = 2801.51529345272365
  her.besselzero[892] = 2804.65688606563023
  her.besselzero[893] = 2807.79847866020748
  her.besselzero[894] = 2810.94007127303946
  her.besselzero[895] = 2814.08166386813221
  her.besselzero[896] = 2817.22325648089686
  her.besselzero[897] = 2820.36484907649498
  her.besselzero[898] = 2823.50644168920172
  her.besselzero[899] = 2826.64803428529598
  her.besselzero[900] = 2829.78962689795032
  her.besselzero[901] = 2832.93121949451798
  her.besselzero[902] = 2836.07281210710979
  her.besselzero[903] = 2839.21440470416364
  her.besselzero[904] = 2842.35599731682508
  her.besselzero[905] = 2845.49758991447898
  her.besselzero[906] = 2848.63918252679493
  her.besselzero[907] = 2851.78077512341943
  her.besselzero[908] = 2854.92236773374941
  her.besselzero[909] = 2858.06396033260057
  her.besselzero[910] = 2861.20555295129452
  her.besselzero[911] = 2864.34714554405331
  her.besselzero[912] = 2867.48873816253713
  her.besselzero[913] = 2870.63033075591977
  her.besselzero[914] = 2873.77192337420517
  her.besselzero[915] = 2876.91351596819711
  her.besselzero[916] = 2880.05510858629509
  her.besselzero[917] = 2883.19670118088247
  her.besselzero[918] = 2886.33829379880513
  her.besselzero[919] = 2889.47988639397301
  her.besselzero[920] = 2892.62147901173136
  her.besselzero[921] = 2895.76307160746679
  her.besselzero[922] = 2898.90466422507131
  her.besselzero[923] = 2902.04625682136185
  her.besselzero[924] = 2905.18784943882213
  her.besselzero[925] = 2908.32944203565446
  her.besselzero[926] = 2911.47103465298062
  her.besselzero[927] = 2914.6126272503432
  her.besselzero[928] = 2917.75421986754501
  her.besselzero[929] = 2920.89581246542486
  her.besselzero[930] = 2924.03740508251175
  her.besselzero[931] = 2927.17899768089839
  her.besselzero[932] = 2930.32059029787781
  her.besselzero[933] = 2933.46218289675952
  her.besselzero[934] = 2936.6037755136416
  her.besselzero[935] = 2939.74536811300701
  her.besselzero[936] = 2942.88696072979902
  her.besselzero[937] = 2946.02855332963908
  her.besselzero[938] = 2949.1701459463492
  her.besselzero[939] = 2952.31173854665218
  her.besselzero[940] = 2955.4533311632877
  her.besselzero[941] = 2958.59492376404489
  her.besselzero[942] = 2961.73651638061308
  her.besselzero[943] = 2964.87810898181471
  her.besselzero[944] = 2968.01970159832162
  her.besselzero[945] = 2971.16129419995811
  her.besselzero[946] = 2974.30288681641297
  her.besselzero[947] = 2977.44447941847525
  her.besselzero[948] = 2980.58607203488268
  her.besselzero[949] = 2983.72766463736169
  her.besselzero[950] = 2986.86925725372898
  her.besselzero[951] = 2990.01084985661602
  her.besselzero[952] = 2993.1524424729492
  her.besselzero[953] = 2996.29403507623592
  her.besselzero[954] = 2999.43562769254068
  her.besselzero[955] = 3002.57722029621954
  her.besselzero[956] = 3005.71881291250164
  her.besselzero[957] = 3008.86040551656508
  her.besselzero[958] = 3012.00199813282898
  her.besselzero[959] = 3015.143590737269
  her.besselzero[960] = 3018.28518335352091
  her.besselzero[961] = 3021.42677595832997
  her.besselzero[962] = 3024.56836857457478
  her.besselzero[963] = 3027.70996117974577
  her.besselzero[964] = 3030.85155379598836
  her.besselzero[965] = 3033.99314640151462
  her.besselzero[966] = 3037.13473901775987
  her.besselzero[967] = 3040.27633162363297
  her.besselzero[968] = 3043.41792423988533
  her.besselzero[969] = 3046.55951684610126
  her.besselzero[970] = 3049.70110946236427
  her.besselzero[971] = 3052.84270206891417
  her.besselzero[972] = 3055.98429468519361
  her.besselzero[973] = 3059.12588729207302
  her.besselzero[974] = 3062.267479908372
  her.besselzero[975] = 3065.40907251557337
  her.besselzero[976] = 3068.55066513189544
  her.besselzero[977] = 3071.69225773941434
  her.besselzero[978] = 3074.8338503557635
  her.besselzero[979] = 3077.97544296359326
  her.besselzero[980] = 3081.11703557997307
  her.besselzero[981] = 3084.25862818810792
  her.besselzero[982] = 3087.40022080452192
  her.besselzero[983] = 3090.54181341295741
  her.besselzero[984] = 3093.68340602941138
  her.besselzero[985] = 3096.82499863814308
  her.besselzero[986] = 3099.96659125462858
  her.besselzero[987] = 3103.10818386362363
  her.besselzero[988] = 3106.24977648013977
  her.besselzero[989] = 3109.39136908951629
  her.besselzero[990] = 3112.53296170630733
  her.besselzero[991] = 3115.67455431584905
  her.besselzero[992] = 3118.81614693106268
  her.besselzero[993] = 3121.95773953739408
  her.besselzero[994] = 3125.09933215131185
  her.besselzero[995] = 3128.24092476527537
  her.besselzero[996] = 3131.38251737928507
  her.besselzero[997] = 3134.52410999334096
  her.besselzero[998] = 3137.66570260744526
  her.besselzero[999] = 3140.80729522159751
  her.besselzero[1000] = 3143.94888783579995
  her.besselzero[1001] = 3147.09048045005257
  her.besselzero[1002] = 3150.2320730643567
  her.besselzero[1003] = 3153.37366567871324
  her.besselzero[1004] = 3156.51525829312218
  her.besselzero[1005] = 3159.65685090758574
  her.besselzero[1006] = 3162.79844352210481
  her.besselzero[1007] = 3165.9400361366794
  her.besselzero[1008] = 3169.08162875131083
  her.besselzero[1009] = 3172.22322136599998
  her.besselzero[1010] = 3175.36481398074776
  her.besselzero[1011] = 3178.5064065955555
  her.besselzero[1012] = 3181.64799921042362
  her.besselzero[1013] = 3184.78959182535259
  her.besselzero[1014] = 3187.93118444034373
  her.besselzero[1015] = 3191.07277705539882
  her.besselzero[1016] = 3194.21436967051786
  her.besselzero[1017] = 3197.35596228570218
  her.besselzero[1018] = 3200.49755490095222
  her.besselzero[1019] = 3203.63914751626888
  her.besselzero[1020] = 3206.78074013165304
  her.besselzero[1021] = 3209.92233274710647
  her.besselzero[1022] = 3213.06392536262919
  her.besselzero[1023] = 3216.20551797822296
  her.besselfactor[0] = 3.71038068570940149
  her.besselfactor[1] = 8.63705996767315831
  her.besselfactor[2] = 13.5710343180866699
  her.besselfactor[3] = 18.5056422933907036
  her.besselfactor[4] = 23.4403774800316755
  her.besselfactor[5] = 28.3751507697616389
  her.besselfactor[6] = 33.3099385387485558
  her.besselfactor[7] = 38.2447327558289487
  her.besselfactor[8] = 43.17953018986592
  her.besselfactor[9] = 48.1143293719934028
  her.besselfactor[10] = 53.0491295694953457
  her.besselfactor[11] = 57.9839303891639268
  her.besselfactor[12] = 62.918731607151157
  her.besselfactor[13] = 67.8535330896593791
  her.besselfactor[14] = 72.7883347533742419
  her.besselfactor[15] = 77.7231365445768496
  her.besselfactor[16] = 82.6579384275732031
  her.besselfactor[17] = 87.5927403780174707
  her.besselfactor[18] = 92.5275423789166495
  her.besselfactor[19] = 97.4623444181659515
  her.besselfactor[20] = 102.397146486983792
  her.besselfactor[21] = 107.331948578894964
  her.besselfactor[22] = 112.266750689053695
  her.besselfactor[23] = 117.201552813784504
  her.besselfactor[24] = 122.136354950265824
  her.besselfactor[25] = 127.071157096306741
  her.besselfactor[26] = 132.00595925018892
  her.besselfactor[27] = 136.940761410551625
  her.besselfactor[28] = 141.875563576308056
  her.besselfactor[29] = 146.810365746582611
  her.besselfactor[30] = 151.745167920665302
  her.besselfactor[31] = 156.679970097975518
  her.besselfactor[32] = 161.614772278035756
  her.besselfactor[33] = 166.549574464209086
  her.besselfactor[34] = 171.484376648335379
  her.besselfactor[35] = 176.419178834246892
  her.besselfactor[36] = 181.353981021707255
  her.besselfactor[37] = 186.288783210517223
  her.besselfactor[38] = 191.223585400506657
  her.besselfactor[39] = 196.158387591531564
  her.besselfactor[40] = 201.093189783467574
  her.besselfactor[41] = 206.027991976208735
  her.besselfactor[42] = 210.962794169662704
  her.besselfactor[43] = 215.897596363749677
  her.besselfactor[44] = 220.832398558401266
  her.besselfactor[45] = 225.767200753556718
  her.besselfactor[46] = 230.702002949163098
  her.besselfactor[47] = 235.63680514517471
  her.besselfactor[48] = 240.571607341550386
  her.besselfactor[49] = 245.506409538254732
  her.besselfactor[50] = 250.441211735255375
  her.besselfactor[51] = 255.376013932524958
  her.besselfactor[52] = 260.310816130037858
  her.besselfactor[53] = 265.24561832777227
  her.besselfactor[54] = 270.180420525708253
  her.besselfactor[55] = 275.115222723828267
  her.besselfactor[56] = 280.050024922115969
  her.besselfactor[57] = 284.98482712055706
  her.besselfactor[58] = 289.919629319139193
  her.besselfactor[59] = 294.854431517850414
  her.besselfactor[60] = 299.789233716680225
  her.besselfactor[61] = 304.724035915619495
  her.besselfactor[62] = 309.65883811465904
  her.besselfactor[63] = 314.593640313792377
  her.besselfactor[64] = 319.528442513010757
  her.besselfactor[65] = 324.463244712309029
  her.besselfactor[66] = 329.398046911680619
  her.besselfactor[67] = 334.332849111120555
  her.besselfactor[68] = 339.26765131062373
  her.besselfactor[69] = 344.202453510186012
  her.besselfactor[70] = 349.13725570980274
  her.besselfactor[71] = 354.072057909470805
  her.besselfactor[72] = 359.006860109186209
  her.besselfactor[73] = 363.941662308945712
  her.besselfactor[74] = 368.876464508746959
  her.besselfactor[75] = 373.811266708586975
  her.besselfactor[76] = 378.746068908463495
  her.besselfactor[77] = 383.680871108373366
  her.besselfactor[78] = 388.615673308315621
  her.besselfactor[79] = 393.550475508286989
  her.besselfactor[80] = 398.485277708287188
  her.besselfactor[81] = 403.420079908313589
  her.besselfactor[82] = 408.354882108364147
  her.besselfactor[83] = 413.28968430843842
  her.besselfactor[84] = 418.224486508534454
  her.besselfactor[85] = 423.159288708651715
  her.besselfactor[86] = 428.094090908787983
  her.besselfactor[87] = 433.028893108942902
  her.besselfactor[88] = 437.963695309114608
  her.besselfactor[89] = 442.898497509303457
  her.besselfactor[90] = 447.833299709507137
  her.besselfactor[91] = 452.768101909726095
  her.besselfactor[92] = 457.702904109958819
  her.besselfactor[93] = 462.637706310204688
  her.besselfactor[94] = 467.57250851046308
  her.besselfactor[95] = 472.507310710733285
  her.besselfactor[96] = 477.442112911014326
  her.besselfactor[97] = 482.376915111306292
  her.besselfactor[98] = 487.311717311608738
  her.besselfactor[99] = 492.246519511920688
  her.besselfactor[100] = 497.181321712241253
  her.besselfactor[101] = 502.116123912570788
  her.besselfactor[102] = 507.050926112909028
  her.besselfactor[103] = 511.985728313254462
  her.besselfactor[104] = 516.920530513608422
  her.besselfactor[105] = 521.855332713969133
  her.besselfactor[106] = 526.790134914336327
  her.besselfactor[107] = 531.72493711471036
  her.besselfactor[108] = 536.659739315090167
  her.besselfactor[109] = 541.594541515476457
  her.besselfactor[110] = 546.529343715867899
  her.besselfactor[111] = 551.464145916265024
  her.besselfactor[112] = 556.398948116667035
  her.besselfactor[113] = 561.333750317074997
  her.besselfactor[114] = 566.268552517486778
  her.besselfactor[115] = 571.203354717903799
  her.besselfactor[116] = 576.138156918324462
  her.besselfactor[117] = 581.072959118749743
  her.besselfactor[118] = 586.007761319178843
  her.besselfactor[119] = 590.942563519611674
  her.besselfactor[120] = 595.877365720048324
  her.besselfactor[121] = 600.812167920488615
  her.besselfactor[122] = 605.74697012093237
  her.besselfactor[123] = 610.681772321378879
  her.besselfactor[124] = 615.616574521828674
  her.besselfactor[125] = 620.551376722281577
  her.besselfactor[126] = 625.486178922737146
  her.besselfactor[127] = 630.420981123196089
  her.besselfactor[128] = 635.355783323656897
  her.besselfactor[129] = 640.290585524120281
  her.besselfactor[130] = 645.225387724586862
  her.besselfactor[131] = 650.160189925055043
  her.besselfactor[132] = 655.094992125525799
  her.besselfactor[133] = 660.02979432599913
  her.besselfactor[134] = 664.964596526474327
  her.besselfactor[135] = 669.899398726951211
  her.besselfactor[136] = 674.834200927430138
  her.besselfactor[137] = 679.76900312791173
  her.besselfactor[138] = 684.703805328394743
  her.besselfactor[139] = 689.638607528878555
  her.besselfactor[140] = 694.573409729365032
  her.besselfactor[141] = 699.508211929853285
  her.besselfactor[142] = 704.443014130342515
  her.besselfactor[143] = 709.377816330833432
  her.besselfactor[144] = 714.312618531325504
  her.besselfactor[145] = 719.247420731819886
  her.besselfactor[146] = 724.182222932315333
  her.besselfactor[147] = 729.117025132812024
  her.besselfactor[148] = 734.051827333309603
  her.besselfactor[149] = 738.986629533808958
  her.besselfactor[150] = 743.921431734309646
  her.besselfactor[151] = 748.856233934810955
  her.besselfactor[152] = 753.791036135313419
  her.besselfactor[153] = 758.725838335816682
  her.besselfactor[154] = 763.660640536321277
  her.besselfactor[155] = 768.595442736827116
  her.besselfactor[156] = 773.530244937334288
  her.besselfactor[157] = 778.465047137841814
  her.besselfactor[158] = 783.399849338350673
  her.besselfactor[159] = 788.334651538860509
  her.besselfactor[160] = 793.269453739370344
  her.besselfactor[161] = 798.204255939881335
  her.besselfactor[162] = 803.139058140393302
  her.besselfactor[163] = 808.073860340906513
  her.besselfactor[164] = 813.008662541420434
  her.besselfactor[165] = 817.943464741934711
  her.besselfactor[166] = 822.878266942449521
  her.besselfactor[167] = 827.813069142965396
  her.besselfactor[168] = 832.747871343481982
  her.besselfactor[169] = 837.682673543999101
  her.besselfactor[170] = 842.617475744517285
  her.besselfactor[171] = 847.552277945035115
  her.besselfactor[172] = 852.487080145554365
  her.besselfactor[173] = 857.421882346073616
  her.besselfactor[174] = 862.356684546594109
  her.besselfactor[175] = 867.291486747114781
  her.besselfactor[176] = 872.226288947635808
  her.besselfactor[177] = 877.161091148157545
  her.besselfactor[178] = 882.095893348679638
  her.besselfactor[179] = 887.030695549203151
  her.besselfactor[180] = 891.965497749726665
  her.besselfactor[181] = 896.900299950250001
  her.besselfactor[182] = 901.835102150774403
  her.besselfactor[183] = 906.769904351298983
  her.besselfactor[184] = 911.704706551823917
  her.besselfactor[185] = 916.639508752349385
  her.besselfactor[186] = 921.574310952875563
  her.besselfactor[187] = 926.509113153401564
  her.besselfactor[188] = 931.44391535392792
  her.besselfactor[189] = 936.378717554455874
  her.besselfactor[190] = 941.313519754982941
  her.besselfactor[191] = 946.24832195550983
  her.besselfactor[192] = 951.183124156038672
  her.besselfactor[193] = 956.11792635656716
  her.besselfactor[194] = 961.05272855709618
  her.besselfactor[195] = 965.987530757625378
  her.besselfactor[196] = 970.922332958154221
  her.besselfactor[197] = 975.85713515868413
  her.besselfactor[198] = 980.791937359214571
  her.besselfactor[199] = 985.726739559744657
  her.besselfactor[200] = 990.661541760275987
  her.besselfactor[201] = 995.596343960806606
  her.besselfactor[202] = 1000.53114616133731
  her.besselfactor[203] = 1005.4659483618682
  her.besselfactor[204] = 1010.40075056240064
  her.besselfactor[205] = 1015.33555276293308
  her.besselfactor[206] = 1020.27035496346485
  her.besselfactor[207] = 1025.20515716399707
  her.besselfactor[208] = 1030.13995936452906
  her.besselfactor[209] = 1035.07476156506283
  her.besselfactor[210] = 1040.00956376559505
  her.besselfactor[211] = 1044.94436596612927
  her.besselfactor[212] = 1049.87916816666282
  her.besselfactor[213] = 1054.81397036719615
  her.besselfactor[214] = 1059.74877256773036
  her.besselfactor[215] = 1064.6835747682648
  her.besselfactor[216] = 1069.6183769687988
  her.besselfactor[217] = 1074.55317916933346
  her.besselfactor[218] = 1079.48798136986812
  her.besselfactor[219] = 1084.42278357040366
  her.besselfactor[220] = 1089.35758577093766
  her.besselfactor[221] = 1094.29238797147299
  her.besselfactor[222] = 1099.22719017200876
  her.besselfactor[223] = 1104.16199237254386
  her.besselfactor[224] = 1109.09679457308052
  her.besselfactor[225] = 1114.03159677361562
  her.besselfactor[226] = 1118.96639897415228
  her.besselfactor[227] = 1123.90120117468828
  her.besselfactor[228] = 1128.83600337522471
  her.besselfactor[229] = 1133.7708055757607
  her.besselfactor[230] = 1138.70560777629714
  her.besselfactor[231] = 1143.64040997683402
  her.besselfactor[232] = 1148.57521217737135
  her.besselfactor[233] = 1153.51001437790801
  her.besselfactor[234] = 1158.44481657844555
  her.besselfactor[235] = 1163.37961877898199
  her.besselfactor[236] = 1168.31442097951976
  her.besselfactor[237] = 1173.24922318005797
  her.besselfactor[238] = 1178.18402538059596
  her.besselfactor[239] = 1183.11882758113394
  her.besselfactor[240] = 1188.05362978167083
  her.besselfactor[241] = 1192.9884319822095
  her.besselfactor[242] = 1197.9232341827477
  her.besselfactor[243] = 1202.85803638328525
  her.besselfactor[244] = 1207.79283858382346
  her.besselfactor[245] = 1212.72764078436168
  her.besselfactor[246] = 1217.66244298490078
  her.besselfactor[247] = 1222.59724518543944
  her.besselfactor[248] = 1227.53204738597831
  her.besselfactor[249] = 1232.46684958651675
  her.besselfactor[250] = 1237.40165178705607
  her.besselfactor[251] = 1242.33645398759517
  her.besselfactor[252] = 1247.27125618813383
  her.besselfactor[253] = 1252.20605838867382
  her.besselfactor[254] = 1257.14086058921248
  her.besselfactor[255] = 1262.07566278975225
  her.besselfactor[256] = 1267.01046499029135
  her.besselfactor[257] = 1271.94526719083045
  her.besselfactor[258] = 1276.8800693913711
  her.besselfactor[259] = 1281.81487159191021
  her.besselfactor[260] = 1286.74967379244931
  her.besselfactor[261] = 1291.68447599298929
  her.besselfactor[262] = 1296.61927819352973
  her.besselfactor[263] = 1301.55408039406994
  her.besselfactor[264] = 1306.48888259460904
  her.besselfactor[265] = 1311.42368479514992
  her.besselfactor[266] = 1316.35848699569013
  her.besselfactor[267] = 1321.2932891962299
  her.besselfactor[268] = 1326.228091396771
  her.besselfactor[269] = 1331.16289359731077
  her.besselfactor[270] = 1336.09769579785075
  her.besselfactor[271] = 1341.03249799839163
  her.besselfactor[272] = 1345.96730019893295
  her.besselfactor[273] = 1350.90210239947339
  her.besselfactor[274] = 1355.83690460001382
  her.besselfactor[275] = 1360.77170680055448
  her.besselfactor[276] = 1365.70650900109447
  her.besselfactor[277] = 1370.64131120163579
  her.besselfactor[278] = 1375.57611340217755
  her.besselfactor[279] = 1380.51091560271821
  her.besselfactor[280] = 1385.44571780325842
  her.besselfactor[281] = 1390.38052000380041
  her.besselfactor[282] = 1395.31532220434172
  her.besselfactor[283] = 1400.25012440488216
  her.besselfactor[284] = 1405.184926605423
  her.besselfactor[285] = 1410.11972880596463
  her.besselfactor[286] = 1415.05453100650546
  her.besselfactor[287] = 1419.98933320704656
  her.besselfactor[288] = 1424.92413540758944
  her.besselfactor[289] = 1429.85893760813054
  her.besselfactor[290] = 1434.79373980867137
  her.besselfactor[291] = 1439.72854200921318
  her.besselfactor[292] = 1444.66334420975499
  her.besselfactor[293] = 1449.59814641029716
  her.besselfactor[294] = 1454.53294861083808
  her.besselfactor[295] = 1459.46775081137953
  her.besselfactor[296] = 1464.40255301192134
  her.besselfactor[297] = 1469.33735521246262
  her.besselfactor[298] = 1474.27215741300621
  her.besselfactor[299] = 1479.20695961354731
  her.besselfactor[300] = 1484.14176181408858
  her.besselfactor[301] = 1489.07656401463128
  her.besselfactor[302] = 1494.01136621517309
  her.besselfactor[303] = 1498.94616841571455
  her.besselfactor[304] = 1503.88097061625618
  her.besselfactor[305] = 1508.81577281679906
  her.besselfactor[306] = 1513.75057501734078
  her.besselfactor[307] = 1518.68537721788303
  her.besselfactor[308] = 1523.62017941842537
  her.besselfactor[309] = 1528.55498161896719
  her.besselfactor[310] = 1533.48978381950988
  her.besselfactor[311] = 1538.42458602005249
  her.besselfactor[312] = 1543.3593882205951
  her.besselfactor[313] = 1548.29419042113674
  her.besselfactor[314] = 1553.22899262167934
  her.besselfactor[315] = 1558.16379482222195
  her.besselfactor[316] = 1563.09859702276376
  her.besselfactor[317] = 1568.03339922330708
  her.besselfactor[318] = 1572.96820142384952
  her.besselfactor[319] = 1577.90300362439195
  her.besselfactor[320] = 1582.8378058249342
  her.besselfactor[321] = 1587.77260802547681
  her.besselfactor[322] = 1592.70741022601818
  her.besselfactor[323] = 1597.64221242656168
  her.besselfactor[324] = 1602.57701462710366
  her.besselfactor[325] = 1607.51181682764681
  her.besselfactor[326] = 1612.44661902819004
  her.besselfactor[327] = 1617.38142122873362
  her.besselfactor[328] = 1622.3162234292765
  her.besselfactor[329] = 1627.25102562981831
  her.besselfactor[330] = 1632.18582783036181
  her.besselfactor[331] = 1637.1206300309038
  her.besselfactor[332] = 1642.05543223144667
  her.besselfactor[333] = 1646.99023443198955
  her.besselfactor[334] = 1651.92503663253269
  her.besselfactor[335] = 1656.85983883307486
  her.besselfactor[336] = 1661.79464103361818
  her.besselfactor[337] = 1666.72944323416061
  her.besselfactor[338] = 1671.66424543470419
  her.besselfactor[339] = 1676.59904763524707
  her.besselfactor[340] = 1681.53384983579101
  her.besselfactor[341] = 1686.46865203633433
  her.besselfactor[342] = 1691.40345423687499
  her.besselfactor[343] = 1696.33825643742035
  her.besselfactor[344] = 1701.27305863796181
  her.besselfactor[345] = 1706.20786083850495
  her.besselfactor[346] = 1711.14266303904827
  her.besselfactor[347] = 1716.07746523959185
  her.besselfactor[348] = 1721.01226744013509
  her.besselfactor[349] = 1725.94706964067823
  her.besselfactor[350] = 1730.88187184122084
  her.besselfactor[351] = 1735.81667404176336
  her.besselfactor[352] = 1740.75147624230686
  her.besselfactor[353] = 1745.68627844285124
  her.besselfactor[354] = 1750.62108064339305
  her.besselfactor[355] = 1755.55588284393522
  her.besselfactor[356] = 1760.49068504447987
  her.besselfactor[357] = 1765.42548724502417
  her.besselfactor[358] = 1770.36028944556589
  her.besselfactor[359] = 1775.29509164611054
  her.besselfactor[360] = 1780.22989384665253
  her.besselfactor[361] = 1785.16469604719745
  her.besselfactor[362] = 1790.09949824774068
  her.besselfactor[363] = 1795.03430044828249
  her.besselfactor[364] = 1799.9691026488267
  her.besselfactor[365] = 1804.90390484937108
  her.besselfactor[366] = 1809.83870704991396
  her.besselfactor[367] = 1814.77350925045826
  her.besselfactor[368] = 1819.70831145100149
  her.besselfactor[369] = 1824.64311365154472
  her.besselfactor[370] = 1829.57791585208759
  her.besselfactor[371] = 1834.51271805263118
  her.besselfactor[372] = 1839.44752025317441
  her.besselfactor[373] = 1844.382322453718
  her.besselfactor[374] = 1849.31712465426194
  her.besselfactor[375] = 1854.25192685480553
  her.besselfactor[376] = 1859.18672905534982
  her.besselfactor[377] = 1864.12153125589341
  her.besselfactor[378] = 1869.05633345643664
  her.besselfactor[379] = 1873.99113565697987
  her.besselfactor[380] = 1878.92593785752346
  her.besselfactor[381] = 1883.86074005806776
  her.besselfactor[382] = 1888.79554225861099
  her.besselfactor[383] = 1893.73034445915315
  her.besselfactor[384] = 1898.66514665969816
  her.besselfactor[385] = 1903.59994886024139
  her.besselfactor[386] = 1908.53475106078604
  her.besselfactor[387] = 1913.46955326132963
  her.besselfactor[388] = 1918.40435546187215
  her.besselfactor[389] = 1923.33915766241609
  her.besselfactor[390] = 1928.27395986295897
  her.besselfactor[391] = 1933.20876206350291
  her.besselfactor[392] = 1938.14356426404614
  her.besselfactor[393] = 1943.07836646459151
  her.besselfactor[394] = 1948.01316866513509
  her.besselfactor[395] = 1952.94797086567832
  her.besselfactor[396] = 1957.88277306622298
  her.besselfactor[397] = 1962.8175752667655
  her.besselfactor[398] = 1967.75237746731015
  her.besselfactor[399] = 1972.68717966785338
  her.besselfactor[400] = 1977.62198186839732
  her.besselfactor[401] = 1982.55678406894091
  her.besselfactor[402] = 1987.49158626948521
  her.besselfactor[403] = 1992.42638847002879
  her.besselfactor[404] = 1997.36119067057309
  her.besselfactor[405] = 2002.29599287111792
  her.besselfactor[406] = 2007.2307950716608
  her.besselfactor[407] = 2012.165597272205
  her.besselfactor[408] = 2017.10039947274966
  her.besselfactor[409] = 2022.03520167329253
  her.besselfactor[410] = 2026.97000387383496
  her.besselfactor[411] = 2031.90480607437917
  her.besselfactor[412] = 2036.83960827492382
  her.besselfactor[413] = 2041.77441047546714
  her.besselfactor[414] = 2046.70921267601091
  her.besselfactor[415] = 2051.64401487655512
  her.besselfactor[416] = 2056.57881707709888
  her.besselfactor[417] = 2061.51361927764309
  her.besselfactor[418] = 2066.44842147818685
  her.besselfactor[419] = 2071.38322367873106
  her.besselfactor[420] = 2076.31802587927527
  her.besselfactor[421] = 2081.25282807981815
  her.besselfactor[422] = 2086.18763028036457
  her.besselfactor[423] = 2091.12243248090745
  her.besselfactor[424] = 2096.05723468145166
  her.besselfactor[425] = 2100.99203688199498
  her.besselfactor[426] = 2105.92683908253919
  her.besselfactor[427] = 2110.86164128308295
  her.besselfactor[428] = 2115.79644348362716
  her.besselfactor[429] = 2120.73124568417048
  her.besselfactor[430] = 2125.66604788471469
  her.besselfactor[431] = 2130.60085008525934
  her.besselfactor[432] = 2135.53565228580133
  her.besselfactor[433] = 2140.47045448634687
  her.besselfactor[434] = 2145.40525668689152
  her.besselfactor[435] = 2150.34005888743484
  her.besselfactor[436] = 2155.27486108798038
  her.besselfactor[437] = 2160.20966328852326
  her.besselfactor[438] = 2165.14446548906747
  her.besselfactor[439] = 2170.07926768961123
  her.besselfactor[440] = 2175.01406989015544
  her.besselfactor[441] = 2179.9488720906992
  her.besselfactor[442] = 2184.88367429124341
  her.besselfactor[443] = 2189.81847649178806
  her.besselfactor[444] = 2194.75327869233227
  her.besselfactor[445] = 2199.68808089287604
  her.besselfactor[446] = 2204.62288309342113
  her.besselfactor[447] = 2209.55768529396578
  her.besselfactor[448] = 2214.4924874945091
  her.besselfactor[449] = 2219.42728969505198
  her.besselfactor[450] = 2224.36209189559619
  her.besselfactor[451] = 2229.29689409614129
  her.besselfactor[452] = 2234.23169629668638
  her.besselfactor[453] = 2239.16649849722748
  her.besselfactor[454] = 2244.10130069777213
  her.besselfactor[455] = 2249.03610289831856
  her.besselfactor[456] = 2253.97090509886233
  her.besselfactor[457] = 2258.90570729940609
  her.besselfactor[458] = 2263.8405094999503
  her.besselfactor[459] = 2268.77531170049318
  her.besselfactor[460] = 2273.71011390103827
  her.besselfactor[461] = 2278.64491610158204
  her.besselfactor[462] = 2283.57971830212624
  her.besselfactor[463] = 2288.5145205026709
  her.besselfactor[464] = 2293.44932270321555
  her.besselfactor[465] = 2298.3841249037602
  her.besselfactor[466] = 2303.31892710430397
  her.besselfactor[467] = 2308.2537293048464
  her.besselfactor[468] = 2313.18853150539283
  her.besselfactor[469] = 2318.12333370593526
  her.besselfactor[470] = 2323.05813590648124
  her.besselfactor[471] = 2327.99293810702545
  her.besselfactor[472] = 2332.92774030756788
  her.besselfactor[473] = 2337.86254250811165
  her.besselfactor[474] = 2342.7973447086563
  her.besselfactor[475] = 2347.73214690920228
  her.besselfactor[476] = 2352.6669491097456
  her.besselfactor[477] = 2357.60175131029026
  her.besselfactor[478] = 2362.53655351083313
  her.besselfactor[479] = 2367.47135571137823
  her.besselfactor[480] = 2372.40615791192421
  her.besselfactor[481] = 2377.34096011246887
  her.besselfactor[482] = 2382.27576231301174
  her.besselfactor[483] = 2387.21056451355639
  her.besselfactor[484] = 2392.14536671409927
  her.besselfactor[485] = 2397.08016891464392
  her.besselfactor[486] = 2402.01497111518813
  her.besselfactor[487] = 2406.94977331573323
  her.besselfactor[488] = 2411.88457551627699
  her.besselfactor[489] = 2416.81937771682076
  her.besselfactor[490] = 2421.75417991736541
  her.besselfactor[491] = 2426.68898211791006
  her.besselfactor[492] = 2431.62378431845338
  her.besselfactor[493] = 2436.55858651899803
  her.besselfactor[494] = 2441.49338871954402
  her.besselfactor[495] = 2446.42819092008556
  her.besselfactor[496] = 2451.36299312063021
  her.besselfactor[497] = 2456.2977953211762
  her.besselfactor[498] = 2461.23259752172129
  her.besselfactor[499] = 2466.16739972226373
  her.besselfactor[500] = 2471.10220192280838
  her.besselfactor[501] = 2476.03700412335214
  her.besselfactor[502] = 2480.97180632389768
  her.besselfactor[503] = 2485.90660852444056
  her.besselfactor[504] = 2490.84141072498477
  her.besselfactor[505] = 2495.77621292553075
  her.besselfactor[506] = 2500.71101512607496
  her.besselfactor[507] = 2505.64581732661961
  her.besselfactor[508] = 2510.58061952716382
  her.besselfactor[509] = 2515.51542172770714
  her.besselfactor[510] = 2520.45022392825135
  her.besselfactor[511] = 2525.38502612879467
  her.besselfactor[512] = 2530.31982832934065
  her.besselfactor[513] = 2535.25463052988531
  her.besselfactor[514] = 2540.18943273042996
  her.besselfactor[515] = 2545.12423493097461
  her.besselfactor[516] = 2550.05903713151749
  her.besselfactor[517] = 2554.99383933206258
  her.besselfactor[518] = 2559.92864153260768
  her.besselfactor[519] = 2564.86344373315011
  her.besselfactor[520] = 2569.7982459336961
  her.besselfactor[521] = 2574.73304813424075
  her.besselfactor[522] = 2579.66785033478407
  her.besselfactor[523] = 2584.60265253533005
  her.besselfactor[524] = 2589.53745473587382
  her.besselfactor[525] = 2594.47225693641669
  her.besselfactor[526] = 2599.40705913696312
  her.besselfactor[527] = 2604.34186133750689
  her.besselfactor[528] = 2609.27666353804976
  her.besselfactor[529] = 2614.21146573859575
  her.besselfactor[530] = 2619.14626793913907
  her.besselfactor[531] = 2624.08107013968372
  her.besselfactor[532] = 2629.01587234022704
  her.besselfactor[533] = 2633.95067454077302
  her.besselfactor[534] = 2638.88547674131723
  her.besselfactor[535] = 2643.82027894186188
  her.besselfactor[536] = 2648.75508114240654
  her.besselfactor[537] = 2653.68988334295075
  her.besselfactor[538] = 2658.62468554349407
  her.besselfactor[539] = 2663.55948774403827
  her.besselfactor[540] = 2668.49428994458337
  her.besselfactor[541] = 2673.42909214512669
  her.besselfactor[542] = 2678.3638943456709
  her.besselfactor[543] = 2683.298696546216
  her.besselfactor[544] = 2688.2334987467602
  her.besselfactor[545] = 2693.16830094730397
  her.besselfactor[546] = 2698.1031031478504
  her.besselfactor[547] = 2703.0379053483946
  her.besselfactor[548] = 2707.97270754893926
  her.besselfactor[549] = 2712.90750974948391
  her.besselfactor[550] = 2717.84231195002634
  her.besselfactor[551] = 2722.77711415057233
  her.besselfactor[552] = 2727.71191635111431
  her.besselfactor[553] = 2732.64671855165985
  her.besselfactor[554] = 2737.58152075220362
  her.besselfactor[555] = 2742.51632295274916
  her.besselfactor[556] = 2747.45112515329426
  her.besselfactor[557] = 2752.38592735383802
  her.besselfactor[558] = 2757.32072955438178
  her.besselfactor[559] = 2762.25553175492732
  her.besselfactor[560] = 2767.19033395546976
  her.besselfactor[561] = 2772.12513615601663
  her.besselfactor[562] = 2777.05993835656084
  her.besselfactor[563] = 2781.99474055710505
  her.besselfactor[564] = 2786.92954275765147
  her.besselfactor[565] = 2791.86434495819435
  her.besselfactor[566] = 2796.799147158739
  her.besselfactor[567] = 2801.73394935928179
  her.besselfactor[568] = 2806.66875155982697
  her.besselfactor[569] = 2811.6035537603734
  her.besselfactor[570] = 2816.53835596091628
  her.besselfactor[571] = 2821.4731581614604
  her.besselfactor[572] = 2826.40796036200381
  her.besselfactor[573] = 2831.34276256255077
  her.besselfactor[574] = 2836.277564763094
  her.besselfactor[575] = 2841.21236696363901
  her.besselfactor[576] = 2846.14716916418419
  her.besselfactor[577] = 2851.08197136472654
  her.besselfactor[578] = 2856.01677356527261
  her.besselfactor[579] = 2860.95157576581691
  her.besselfactor[580] = 2865.88637796635978
  her.besselfactor[581] = 2870.8211801669039
  her.besselfactor[582] = 2875.75598236744944
  her.besselfactor[583] = 2880.69078456799445
  her.besselfactor[584] = 2885.62558676853697
  her.besselfactor[585] = 2890.56038896908376
  her.besselfactor[586] = 2895.4951911696277
  her.besselfactor[587] = 2900.42999337017182
  her.besselfactor[588] = 2905.36479557071647
  her.besselfactor[589] = 2910.29959777125935
  her.besselfactor[590] = 2915.23439997180631
  her.besselfactor[591] = 2920.16920217234989
  her.besselfactor[592] = 2925.10400437289561
  her.besselfactor[593] = 2930.03880657344026
  her.besselfactor[594] = 2934.97360877398207
  her.besselfactor[595] = 2939.90841097452815
  her.besselfactor[596] = 2944.8432131750728
  her.besselfactor[597] = 2949.77801537561479
  her.besselfactor[598] = 2954.71281757616122
  her.besselfactor[599] = 2959.64761977670711
  her.besselfactor[600] = 2964.58242197724874
  her.besselfactor[601] = 2969.51722417779464
  her.besselfactor[602] = 2974.45202637833929
  her.besselfactor[603] = 2979.38682857888448
  her.besselfactor[604] = 2984.3216307794286
  her.besselfactor[605] = 2989.25643297997378
  her.besselfactor[606] = 2994.19123518051844
  her.besselfactor[607] = 2999.12603738106309
  her.besselfactor[608] = 3004.0608395816073
  her.besselfactor[609] = 3008.99564178215195
  her.besselfactor[610] = 3013.93044398269394
  her.besselfactor[611] = 3018.8652461832417
  her.besselfactor[612] = 3023.80004838378324
  her.besselfactor[613] = 3028.73485058433056
  her.besselfactor[614] = 3033.66965278487343
  her.besselfactor[615] = 3038.60445498541764
  her.besselfactor[616] = 3043.53925718596318
  her.besselfactor[617] = 3048.47405938650783
  her.besselfactor[618] = 3053.40886158705071
  her.besselfactor[619] = 3058.34366378759714
  her.besselfactor[620] = 3063.27846598814135
  her.besselfactor[621] = 3068.21326818868467
  her.besselfactor[622] = 3073.1480703892311
  her.besselfactor[623] = 3078.08287258977486
  her.besselfactor[624] = 3083.01767479031996
  her.besselfactor[625] = 3087.95247699086417
  her.besselfactor[626] = 3092.88727919140749
  her.besselfactor[627] = 3097.82208139195169
  her.besselfactor[628] = 3102.75688359249723
  her.besselfactor[629] = 3107.69168579304011
  her.besselfactor[630] = 3112.62648799358609
  her.besselfactor[631] = 3117.56129019413119
  her.besselfactor[632] = 3122.49609239467762
  her.besselfactor[633] = 3127.43089459521961
  her.besselfactor[634] = 3132.3656967957647
  her.besselfactor[635] = 3137.30049899631069
  her.besselfactor[636] = 3142.23530119685401
  her.besselfactor[637] = 3147.17010339739644
  her.besselfactor[638] = 3152.1049055979442
  her.besselfactor[639] = 3157.03970779848663
  her.besselfactor[640] = 3161.97450999903306
  her.besselfactor[641] = 3166.90931219957594
  her.besselfactor[642] = 3171.84411440012059
  her.besselfactor[643] = 3176.77891660066613
  her.besselfactor[644] = 3181.71371880121034
  her.besselfactor[645] = 3186.64852100175366
  her.besselfactor[646] = 3191.58332320229964
  her.besselfactor[647] = 3196.51812540284563
  her.besselfactor[648] = 3201.45292760339028
  her.besselfactor[649] = 3206.3877298039336
  her.besselfactor[650] = 3211.32253200447781
  her.besselfactor[651] = 3216.25733418877768
  her.besselfactor[652] = 3221.19213642157919
  her.besselfactor[653] = 3226.12693859039234
  her.besselfactor[654] = 3231.06174082215025
  her.besselfactor[655] = 3235.99654299199102
  her.besselfactor[656] = 3240.93134522273862
  her.besselfactor[657] = 3245.86614739357282
  her.besselfactor[658] = 3250.8009496233412
  her.besselfactor[659] = 3255.73575179513863
  her.besselfactor[660] = 3260.67055402395888
  her.besselfactor[661] = 3265.60535619668934
  her.besselfactor[662] = 3270.54015842459611
  her.besselfactor[663] = 3275.47496059822318
  her.besselfactor[664] = 3280.40976282524443
  her.besselfactor[665] = 3285.34456499974414
  her.besselfactor[666] = 3290.27936722590874
  her.besselfactor[667] = 3295.21416940125266
  her.besselfactor[668] = 3300.14897162658504
  her.besselfactor[669] = 3305.08377380274254
  her.besselfactor[670] = 3310.01857602727733
  her.besselfactor[671] = 3314.95337820422397
  her.besselfactor[672] = 3319.88818042798206
  her.besselfactor[673] = 3324.82298260569786
  her.besselfactor[674] = 3329.75778482870055
  her.besselfactor[675] = 3334.69258700712734
  her.besselfactor[676] = 3339.62738922935864
  her.besselfactor[677] = 3344.56219140852883
  her.besselfactor[678] = 3349.49699363034847
  her.besselfactor[679] = 3354.43179581058581
  her.besselfactor[680] = 3359.36659803085913
  her.besselfactor[681] = 3364.30140020768231
  her.besselfactor[682] = 3369.23620242190446
  her.besselfactor[683] = 3374.17100460427121
  her.besselfactor[684] = 3379.10580684091144
  her.besselfactor[685] = 3384.04060900594583
  her.besselfactor[686] = 3388.97541124142165
  her.besselfactor[687] = 3393.91021340760579
  her.besselfactor[688] = 3398.84501564195184
  her.besselfactor[689] = 3403.77981780924443
  her.besselfactor[690] = 3408.71462004249536
  her.besselfactor[691] = 3413.64942221086398
  her.besselfactor[692] = 3418.5842244430602
  her.besselfactor[693] = 3423.51902661246887
  her.besselfactor[694] = 3428.45382884364147
  her.besselfactor[695] = 3433.38863101405555
  her.besselfactor[696] = 3438.32343324424005
  her.besselfactor[697] = 3443.25823541562803
  her.besselfactor[698] = 3448.19303764485463
  her.besselfactor[699] = 3453.12783981718496
  her.besselfactor[700] = 3458.06264204548474
  her.besselfactor[701] = 3462.99744421872413
  her.besselfactor[702] = 3467.93224644612729
  her.besselfactor[703] = 3472.86704862025041
  her.besselfactor[704] = 3477.80185084678672
  her.besselfactor[705] = 3482.73665302176471
  her.besselfactor[706] = 3487.67145524745947
  her.besselfactor[707] = 3492.60625742326169
  her.besselfactor[708] = 3497.54105964814598
  her.besselfactor[709] = 3502.47586182474535
  her.besselfactor[710] = 3507.41066404884671
  her.besselfactor[711] = 3512.34546622622634
  her.besselfactor[712] = 3517.28026844956298
  her.besselfactor[713] = 3522.21507062765937
  her.besselfactor[714] = 3527.14987285021219
  her.besselfactor[715] = 3532.08467502906486
  her.besselfactor[716] = 3537.01947725120202
  her.besselfactor[717] = 3541.95427943113605
  her.besselfactor[718] = 3546.88908165170513
  her.besselfactor[719] = 3551.82388382816904
  her.besselfactor[720] = 3556.7586860425977
  her.besselfactor[721] = 3561.69348822469
  her.besselfactor[722] = 3566.62829046187201
  her.besselfactor[723] = 3571.56309262637439
  her.besselfactor[724] = 3576.49789486237779
  her.besselfactor[725] = 3581.43269702803968
  her.besselfactor[726] = 3586.36749926289777
  her.besselfactor[727] = 3591.30230142968631
  her.besselfactor[728] = 3596.23710366343729
  her.besselfactor[729] = 3601.17190583131741
  her.besselfactor[730] = 3606.10670806399502
  her.besselfactor[731] = 3611.04151023292718
  her.besselfactor[732] = 3615.97631246457007
  her.besselfactor[733] = 3620.91111463452275
  her.besselfactor[734] = 3625.84591686516111
  her.besselfactor[735] = 3630.78071903610055
  her.besselfactor[736] = 3635.71552126576813
  her.besselfactor[737] = 3640.65032343766414
  her.besselfactor[738] = 3645.58512566639203
  her.besselfactor[739] = 3650.51992783920686
  her.besselfactor[740] = 3655.45473006703014
  her.besselfactor[741] = 3660.38953224074115
  her.besselfactor[742] = 3665.32433446768113
  her.besselfactor[743] = 3670.259136642259
  her.besselfactor[744] = 3675.19393886834766
  her.besselfactor[745] = 3680.1287410437653
  her.besselfactor[746] = 3685.0635432690284
  her.besselfactor[747] = 3689.99834544525473
  her.besselfactor[748] = 3694.93314766971625
  her.besselfactor[749] = 3699.86794984672595
  her.besselfactor[750] = 3704.80275207044673
  her.besselfactor[751] = 3709.73755424826734
  her.besselfactor[752] = 3714.67235647120741
  her.besselfactor[753] = 3719.60715864945745
  her.besselfactor[754] = 3724.54196087128508
  her.besselfactor[755] = 3729.47676305115161
  her.besselfactor[756] = 3734.4115652765546
  her.besselfactor[757] = 3739.34636746274851
  her.besselfactor[758] = 3744.28116968235169
  her.besselfactor[759] = 3749.21597184512256
  her.besselfactor[760] = 3754.1507740828286
  her.besselfactor[761] = 3759.08557624681671
  her.besselfactor[762] = 3764.0203784833246
  her.besselfactor[763] = 3768.95518064848911
  her.besselfactor[764] = 3773.88998288383703
  her.besselfactor[765] = 3778.82478505013841
  her.besselfactor[766] = 3783.75958728437211
  her.besselfactor[767] = 3788.69438945177483
  her.besselfactor[768] = 3793.6291916849214
  her.besselfactor[769] = 3798.56399385339482
  her.besselfactor[770] = 3803.49879608548846
  her.besselfactor[771] = 3808.43359825499447
  her.besselfactor[772] = 3813.36840048607417
  her.besselfactor[773] = 3818.30320265657832
  her.besselfactor[774] = 3823.23800488667675
  her.besselfactor[775] = 3828.17280705814724
  her.besselfactor[776] = 3833.10760928729408
  her.besselfactor[777] = 3838.0424114597007
  her.besselfactor[778] = 3842.97721368792455
  her.besselfactor[779] = 3847.91201586123587
  her.besselfactor[780] = 3852.8468180885703
  her.besselfactor[781] = 3857.7816202627595
  her.besselfactor[782] = 3862.71642248923186
  her.besselfactor[783] = 3867.651224664273
  her.besselfactor[784] = 3872.58602688990691
  her.besselfactor[785] = 3877.52082906577157
  her.besselfactor[786] = 3882.45563129060187
  her.besselfactor[787] = 3887.39043346723267
  her.besselfactor[788] = 3892.32523569122434
  her.besselfactor[789] = 3897.26003786865593
  her.besselfactor[790] = 3902.19484009220973
  her.besselfactor[791] = 3907.12964227079027
  her.besselfactor[792] = 3912.06444449267465
  her.besselfactor[793] = 3916.99924666755894
  her.besselfactor[794] = 3921.93404888289833
  her.besselfactor[795] = 3926.86885106377747
  her.besselfactor[796] = 3931.80365330337266
  her.besselfactor[797] = 3936.73845546549614
  her.besselfactor[798] = 3941.67325770383882
  her.besselfactor[799] = 3946.60805986719864
  her.besselfactor[800] = 3951.54286210432346
  her.besselfactor[801] = 3956.47766426888125
  her.besselfactor[802] = 3961.41246650482656
  her.besselfactor[803] = 3966.34726867054521
  her.besselfactor[804] = 3971.28207090535312
  her.besselfactor[805] = 3976.21687307218873
  her.besselfactor[806] = 3981.1516753058953
  her.besselfactor[807] = 3986.08647747381805
  her.besselfactor[808] = 3991.02127970645526
  her.besselfactor[809] = 3995.95608187542481
  her.besselfactor[810] = 4000.89088410703119
  her.besselfactor[811] = 4005.8256862770154
  her.besselfactor[812] = 4010.76048850762489
  her.besselfactor[813] = 4015.69529067859143
  her.besselfactor[814] = 4020.63009290823636
  her.besselfactor[815] = 4025.56489508015324
  her.besselfactor[816] = 4030.49969730885937
  her.besselfactor[817] = 4035.43449948169996
  her.besselfactor[818] = 4040.36930170949837
  her.besselfactor[819] = 4045.30410388322714
  her.besselfactor[820] = 4050.23890611015247
  her.besselfactor[821] = 4055.17370828474543
  her.besselfactor[822] = 4060.10851051082433
  her.besselfactor[823] = 4065.04331268625396
  her.besselfactor[824] = 4069.97811491150862
  her.besselfactor[825] = 4074.91291708771719
  her.besselfactor[826] = 4079.8477193121263
  her.besselfactor[827] = 4084.782521489144
  her.besselfactor[828] = 4089.71732371310814
  her.besselfactor[829] = 4094.6521258913
  her.besselfactor[830] = 4099.58692811356151
  her.besselfactor[831] = 4104.52173028799105
  her.besselfactor[832] = 4109.45653250359654
  her.besselfactor[833] = 4114.39133468412077
  her.besselfactor[834] = 4119.32613692441318
  her.besselfactor[835] = 4124.26093908585844
  her.besselfactor[836] = 4129.19574132486744
  her.besselfactor[837] = 4134.13054348756769
  her.besselfactor[838] = 4139.06534572534212
  her.besselfactor[839] = 4144.0001478892583
  her.besselfactor[840] = 4148.93495012583457
  her.besselfactor[841] = 4153.86975229093202
  her.besselfactor[842] = 4158.80455452635011
  her.besselfactor[843] = 4163.73935669258621
  her.besselfactor[844] = 4168.67415892688608
  her.besselfactor[845] = 4173.60896109421997
  her.besselfactor[846] = 4178.54376332743537
  her.besselfactor[847] = 4183.47856549583774
  her.besselfactor[848] = 4188.41336772800509
  her.besselfactor[849] = 4193.34816989744307
  her.besselfactor[850] = 4198.28297212859169
  her.besselfactor[851] = 4203.21777429902443
  her.besselfactor[852] = 4208.15257652919072
  her.besselfactor[853] = 4213.08737870059424
  her.besselfactor[854] = 4218.02218092980574
  her.besselfactor[855] = 4222.9569831021454
  her.besselfactor[856] = 4227.89178533043941
  her.besselfactor[857] = 4232.82658750368412
  her.besselfactor[858] = 4237.76138973108373
  her.besselfactor[859] = 4242.69619190520597
  her.besselfactor[860] = 4247.63099413174494
  her.besselfactor[861] = 4252.56579630672248
  her.besselfactor[862] = 4257.50059853242923
  her.besselfactor[863] = 4262.43540070819459
  her.besselfactor[864] = 4267.37020293303448
  her.besselfactor[865] = 4272.30500510963029
  her.besselfactor[866] = 4277.23980733401631
  her.besselfactor[867] = 4282.17460951180139
  her.besselfactor[868] = 4287.1094117344608
  her.besselfactor[869] = 4292.04421390841339
  her.besselfactor[870] = 4296.97901612429067
  her.besselfactor[871] = 4301.91381830445429
  her.besselfactor[872] = 4306.84862054546435
  her.besselfactor[873] = 4311.78342270619463
  her.besselfactor[874] = 4316.71822494591062
  her.besselfactor[875] = 4321.65302710791898
  her.besselfactor[876] = 4326.5878293463782
  her.besselfactor[877] = 4331.52263150962113
  her.besselfactor[878] = 4336.45743374685999
  her.besselfactor[879] = 4341.39223591130196
  her.besselfactor[880] = 4346.32703814736665
  her.besselfactor[881] = 4351.26184031296503
  her.besselfactor[882] = 4356.19664254789018
  her.besselfactor[883] = 4361.13144471461211
  her.besselfactor[884] = 4366.06624694843237
  her.besselfactor[885] = 4371.00104911623787
  her.besselfactor[886] = 4375.93585134899143
  her.besselfactor[887] = 4380.87065351785032
  her.besselfactor[888] = 4385.80545574956914
  her.besselfactor[889] = 4390.74025791944411
  her.besselfactor[890] = 4395.67506015015929
  her.besselfactor[891] = 4400.60986232102102
  her.besselfactor[892] = 4405.5446645507672
  her.besselfactor[893] = 4410.47946672258195
  her.besselfactor[894] = 4415.41426895139288
  her.besselfactor[895] = 4420.34907112412689
  her.besselfactor[896] = 4425.28387335202921
  her.besselfactor[897] = 4430.21867552565407
  her.besselfactor[898] = 4435.1534777526842
  her.besselfactor[899] = 4440.08827992717947
  her.besselfactor[900] = 4445.0230821533605
  her.besselfactor[901] = 4449.95788432865868
  her.besselfactor[902] = 4454.89268655395687
  her.besselfactor[903] = 4459.82748873010237
  her.besselfactor[904] = 4464.7622909549387
  her.besselfactor[905] = 4469.69709313229479
  her.besselfactor[906] = 4474.63189535536809
  her.besselfactor[907] = 4479.56669752881886
  her.besselfactor[908] = 4484.50149974498657
  her.besselfactor[909] = 4489.43630192475939
  her.besselfactor[910] = 4494.37110416654483
  her.besselfactor[911] = 4499.30590632651927
  her.besselfactor[912] = 4504.24070856698044
  her.besselfactor[913] = 4509.17551072825251
  her.besselfactor[914] = 4514.11031296743026
  her.besselfactor[915] = 4519.04511512996265
  her.besselfactor[916] = 4523.97991736790405
  her.besselfactor[917] = 4528.9147195316568
  her.besselfactor[918] = 4533.84952176839917
  her.besselfactor[919] = 4538.78432393333319
  her.besselfactor[920] = 4543.71912616891382
  her.besselfactor[921] = 4548.65392833498471
  her.besselfactor[922] = 4553.58873056944624
  her.besselfactor[923] = 4558.52353273662291
  her.besselfactor[924] = 4563.45833496999286
  her.besselfactor[925] = 4568.39313713824246
  her.besselfactor[926] = 4573.32793937055903
  her.besselfactor[927] = 4578.26274153984424
  her.besselfactor[928] = 4583.19754377114385
  her.besselfactor[929] = 4588.13234594143182
  her.besselfactor[930] = 4593.06714817174555
  her.besselfactor[931] = 4598.00195034300251
  her.besselfactor[932] = 4602.93675257236323
  her.besselfactor[933] = 4607.87155474455634
  her.besselfactor[934] = 4612.80635697299334
  her.besselfactor[935] = 4617.74115914609595
  her.besselfactor[936] = 4622.67596137363678
  her.besselfactor[937] = 4627.61076354762046
  her.besselfactor[938] = 4632.54556577429532
  her.besselfactor[939] = 4637.48036794913254
  her.besselfactor[940] = 4642.41517017497251
  her.besselfactor[941] = 4647.34997235062685
  her.besselfactor[942] = 4652.28477457565681
  her.besselfactor[943] = 4657.21957675211406
  her.besselfactor[944] = 4662.15437897635531
  her.besselfactor[945] = 4667.08918115358351
  her.besselfactor[946] = 4672.02398337706803
  her.besselfactor[947] = 4676.95878555504229
  her.besselfactor[948] = 4681.89358777779496
  her.besselfactor[949] = 4686.82838995649397
  her.besselfactor[950] = 4691.76319217853077
  her.besselfactor[951] = 4696.69799435792612
  her.besselfactor[952] = 4701.63279657927635
  her.besselfactor[953] = 4706.56759875935382
  her.besselfactor[954] = 4711.50240098003703
  her.besselfactor[955] = 4716.43720316076731
  her.besselfactor[956] = 4721.37200538080747
  her.besselfactor[957] = 4726.30680756217191
  her.besselfactor[958] = 4731.24160978158414
  her.besselfactor[959] = 4736.17641196356675
  her.besselfactor[960] = 4741.11121418237324
  her.besselfactor[961] = 4746.04601636495004
  her.besselfactor[962] = 4750.98081858317389
  her.besselfactor[963] = 4755.91562076632445
  her.besselfactor[964] = 4760.85042298397986
  her.besselfactor[965] = 4765.78522516769353
  her.besselfactor[966] = 4770.72002738479739
  her.besselfactor[967] = 4775.65482956904663
  her.besselfactor[968] = 4780.58963178562379
  her.besselfactor[969] = 4785.52443397039617
  her.besselfactor[970] = 4790.45923618646174
  her.besselfactor[971] = 4795.39403837173239
  her.besselfactor[972] = 4800.32884058730324
  her.besselfactor[973] = 4805.2636427730615
  her.besselfactor[974] = 4810.19844498814919
  her.besselfactor[975] = 4815.13324717438706
  her.besselfactor[976] = 4820.06804938901201
  her.besselfactor[977] = 4825.00285157570285
  her.besselfactor[978] = 4829.93765378987394
  her.besselfactor[979] = 4834.87245597701509
  her.besselfactor[980] = 4839.80725819074919
  her.besselfactor[981] = 4844.74206037831489
  her.besselfactor[982] = 4849.67686259162622
  her.besselfactor[983] = 4854.61166477961025
  her.besselfactor[984] = 4859.54646699252101
  her.besselfactor[985] = 4864.48126918091006
  her.besselfactor[986] = 4869.41607139340071
  her.besselfactor[987] = 4874.3508735820944
  her.besselfactor[988] = 4879.28567579415783
  her.besselfactor[989] = 4884.2204779835372
  her.besselfactor[990] = 4889.15528019594614
  her.besselfactor[991] = 4894.09008238532639
  her.besselfactor[992] = 4899.02488459227125
  her.besselfactor[993] = 4903.95968677105287
  her.besselfactor[994] = 4908.89448897341473
  her.besselfactor[995] = 4913.82929117566646
  her.besselfactor[996] = 4918.76409337780806
  her.besselfactor[997] = 4923.69889557984308
  her.besselfactor[998] = 4928.63369778177862
  her.besselfactor[999] = 4933.56849998361379
  her.besselfactor[1000] = 4938.50330218536015
  her.besselfactor[1001] = 4943.43810438700792
  her.besselfactor[1002] = 4948.37290658857309
  her.besselfactor[1003] = 4953.30770879005299
  her.besselfactor[1004] = 4958.24251099145651
  her.besselfactor[1005] = 4963.17731319277477
  her.besselfactor[1006] = 4968.1121153940273
  her.besselfactor[1007] = 4973.04691759521055
  her.besselfactor[1008] = 4977.98171979632453
  her.besselfactor[1009] = 4982.91652199737988
  her.besselfactor[1010] = 4987.85132419837484
  her.besselfactor[1011] = 4992.78612639931651
  her.besselfactor[1012] = 4997.72092860020755
  her.besselfactor[1013] = 5002.65573080104797
  her.besselfactor[1014] = 5007.59053300184753
  her.besselfactor[1015] = 5012.5253352026009
  her.besselfactor[1016] = 5017.46013740332053
  her.besselfactor[1017] = 5022.39493960400551
  her.besselfactor[1018] = 5027.32974180466207
  her.besselfactor[1019] = 5032.26454400529554
  her.besselfactor[1020] = 5037.19934620589704
  her.besselfactor[1021] = 5042.13414840648699
  her.besselfactor[1022] = 5047.06895060705829
  her.besselfactor[1023] = 5052.00375280761715

